/* 
	HiformEDWindow.java
	
	Author : Tomokazu ARITA
	Date   : 2000/04/23
	update : 2001/11/28
        update: 2001/12/16
	update: 2002/01/14
        Last update: 2003/01/04
	
*/
package hiformed.editor;

//JDK 1.2.x
import java.awt.Font;
import java.awt.Color;
import java.awt.*;
import java.awt.image.*;
import javax.swing.*;
import javax.swing.border.*;
import java.awt.event.*;
import java.net.*;
import java.io.*;

//hiform
import hiformed.editor.mgpanel.*;
import hiformed.editor.dialog.*;
import hiformed.hngg.Graphs.*;
import hiformed.hngg.NodeSet.*;
import hiformed.hngg.Precedence.*;
import hiformed.hngg.Productions.*;
import hiformed.grammar.*;
import hiformed.parser.*;
import hiformed.editor.derivationtree.*;
import hiformed.editor.mgpanel.*;
import hiformed.editor.table.*;
import hiformed.debug.*;
import hiformed.editor.toolbar.*;

//test
//import hiformed.TestGG.*;//test

public class HiformEDWindow extends JPanel{
	
	MarkedGraph marked_graph    = null;//MarkedGraph
	DTBlock     derivation_tree = null;//Derivation Tree
	String form_name = "";
	
	DTMaker parser; 
	
	static HiformEDWindow main_panel;
	static JFrame    MainFrame;
	static JMenuBar  menu;
	
	
	//demo
		
	static JPanel mg_outside_panel2 = new JPanel();
	//static JPanel mg_inside_panel2 = new JPanel();
	
	static JPanel mg_outside_panel4 = new JPanel();
	//static JPanel mg_inside_panel4 = new JPanel();
	
	static JPanel mg_outside_panel5 = new JPanel();
	//static JPanel mg_inside_panel5 = new JPanel();
	
	static JScrollPane jsp;
	static JScrollPane jsp2;
	static JScrollPane jsp3;
	
	static ReductPanel reduct_panel = new ReductPanel();//
	static EditorCommandPanel editor_command_panel = new EditorCommandPanel();
	
	static JPanel panel2 = new JPanel();
	static JPanel panel3 = new JPanel();
	
	static JPanel panel4 = new JPanel();
	static JPanel panel5 = new JPanel();
	
	static JPanel panel6 = new JPanel();
	
	// ------------------( Main TabbedPane )------------------
	static JTabbedPane main_tabbedpane = new JTabbedPane(JTabbedPane.TOP);
	
		
	// ------------------( innerPanel for Form Drawing)------------------
	//static InnerFormPanel innerPanel = new InnerFormPanel();
	static TablePanel tablePanel = new TablePanel();
	
	
	// ------------------( innerPanel for Marked Graph Drawing)------------------
	static MarkedGraphPanel mgp = new MarkedGraphPanel();
	
	// ------------------( innerPanel for Derivation Tree Drawing)------------------
	static DTreePane dtree_panel = new DTreePane();
	
	
	// ------------------(Animation Panel)------------------
	static DTAnime anime = new DTAnime(); //-anime
	
	// ------------------(Toolbar Panel)------------------
	static HiformEDToolBar toolbar = new HiformEDToolBar();
	
	
	//dialog
	static FileSelectDialog fsd;
	
	public HiformEDWindow(){
		//parser = new DTMaker(new TPSet(), new TestPTable(), new TestNodeSet());///020224
		
		initPanel2();
		initPanel4();
		initPanel5();
		
		setLayout(new BorderLayout());
		main_tabbedpane.add( " Form ", panel2);
		main_tabbedpane.add( " Form Graph ", panel4);//2003/01/05 marked graph -> form graph
		main_tabbedpane.add( " Derivation Tree ", panel6);
		main_tabbedpane.add( " Animation", anime.getAnimePanel());//020218
		add("Center", main_tabbedpane);
		add("North", toolbar);//-----------------------
		
	}


	/*
	static public void main(String[] args){
		main_panel = new HiformEDWindow();
		
		// Frame Set
		WindowListener l = new WindowAdapter() {
			public void windowClosing(WindowEvent e) {
				MainFrame.dispose();
				System.exit(0);
			}
		};
		
		
		
		MainFrame = new JFrame("Hiform");
		MainFrame.addWindowListener(l);
		MainFrame.getContentPane().add("Center",main_panel);
		
		MainFrame.setJMenuBar(makeMenuBar());
		MainFrame.setSize(680,480);
		MainFrame.show();
		
	}
	*/

	public JMenuBar makeMenuBar(){
		menu = new JMenuBar();
		
		/* ******** Menu [ File - start- ] ******** */
		JMenu file_menu = new JMenu("File");
		
		/* Open */
		JMenuItem file_item1  = new JMenuItem("Open");
		ActionListener file_item_event1 = new ActionListener(){
			public void actionPerformed(ActionEvent e){
				fsd = new FileSelectDialog(MainFrame, "Forms");///
				fsd.setSize(200,300);
				fsd.show();
				form_name = fsd.getFormName();
				initMarkedGraph();
			}
		};
		file_item1.addActionListener(file_item_event1);
		
		
		/* Quit */
		JMenuItem file_item2  = new JMenuItem("Quit");
		ActionListener file_item_event2 = new ActionListener(){
			public void actionPerformed(ActionEvent e){
				System.exit(0);
			}
		};
		file_item2.addActionListener(file_item_event2);
		
		
		file_menu.add(file_item1);
		file_menu.addSeparator();
		file_menu.add(file_item2);
		/* ******** Menu [ File -end- ] ******** */
		
		
		menu.add(file_menu);
		menu.add(new JMenu("Edit"));
		menu.add(new JMenu("Option"));
		menu.add(new JMenu("Help"));
		
		//color
		//file_menu.setBackground(HiformEDColor.CBackGround);
		//file_menu.setForeground(HiformEDColor.FontColor);
		//menu.setBackground(HiformEDColor.CBackGround);
		//menu.setForeground(HiformEDColor.FontColor);
		//end color
		
		return menu;
	}
		

	private void initPanel2(){
		mg_outside_panel2.setBorder(new TitledBorder(new EtchedBorder(),"Form Edit"));
		Border border = mg_outside_panel2.getBorder();
		Border margin = new EmptyBorder(0,5,5,5);
		mg_outside_panel2.setBorder(new CompoundBorder(border, margin));
		
		/*
		jsp = new JScrollPane(innerPanel);
		 */
		jsp = new JScrollPane(tablePanel);
		jsp.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED);
		jsp.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
		mg_outside_panel2.setLayout(new BorderLayout());
		mg_outside_panel2.add("Center",jsp);
		
		panel2.setLayout(new BorderLayout());
		panel2.add("Center",mg_outside_panel2);
		//panel2.add("East",reduct_panel); //020204
		
	}

	
	
	private void initPanel4(){
		mg_outside_panel4.setBorder(new TitledBorder(new EtchedBorder(),"Marked Graph Edit"));
		Border border = mg_outside_panel4.getBorder();
		Border margin = new EmptyBorder(0,5,5,5);
		mg_outside_panel4.setBorder(new CompoundBorder(border, margin));
		
		
		jsp2 = new JScrollPane(mgp);
		jsp2.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED);
		jsp2.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
		mg_outside_panel4.setLayout(new BorderLayout());
		mg_outside_panel4.add("Center",jsp2);
		
		panel4.setLayout(new BorderLayout());
		panel4.add("Center",mg_outside_panel4);
		//panel4.add("East",editor_command_panel);//020204
		
	}
	
	private void initPanel5(){
		mg_outside_panel5.setBorder(new TitledBorder(new EtchedBorder(),"Derivation Tree"));
		Border border = mg_outside_panel5.getBorder();
		Border margin = new EmptyBorder(0,5,5,5);
		mg_outside_panel5.setBorder(new CompoundBorder(border, margin));
		
		
		jsp3 = new JScrollPane(dtree_panel);
		jsp3.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED);
		jsp3.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
		mg_outside_panel5.setLayout(new BorderLayout());
		mg_outside_panel5.add("Center",jsp3);
		
		panel6.setLayout(new BorderLayout());
		panel6.add("Center",mg_outside_panel5);
		//panel5.add("East",editor_command_panel);
		
		
	}
	
	
	public void setMarkedGraph(MarkedGraph graph){
		this.marked_graph = graph;
	}
	
	public void setDTree(DTBlock tree){
		this.derivation_tree = tree;
	}
	
	private void initMarkedGraph(){
		if(form_name.equals("")){
			return;
		}else if(form_name.equals("A1")){//set FORM "A1" 
			setMarkedGraph(new MGraphA1());////test
			parser = new DTMaker(new A1PSet(), new PTableA1(), new NodeSetA1());///
			parser.makeDT(marked_graph);
                        
			mgp.setNodeSet(new NodeSetA1());
			mgp.setMarkedGraph(marked_graph);
			
			derivation_tree = parser.getDTree();
			parser.evaluteAttribute(derivation_tree);//evaluate attributes
			
			dtree_panel.setDTree(derivation_tree);// draw derivation tree
                        
                        parser.clear();//perser init.
                        
			tablePanel.setDerivationTree(derivation_tree); //set derivation tree
			tablePanel.drawCells();//draw table
			
			anime.setParameters(marked_graph, new PTableA1(), new A1PSet(), new NodeSetA1());//anime test
			
                        //clear();//init.
                        
		}else{
                    /*
			setMarkedGraph(new TestMGraph());////test
			parser = new DTMaker(new TPSet(), new TestPTable(), new TestNodeSet());///
			parser.makeDT(marked_graph);
			mgp.setNodeSet(new TestNodeSet());
			mgp.setMarkedGraph(marked_graph);
			derivation_tree = parser.getDTree();
			dtree_panel.setDTree(derivation_tree);
                     */
		}
	}
        
        //init. this var.
        public void clear(){
            parser = null;
            marked_graph = null;
            derivation_tree = null;
        }
}



