/* 
	Block.java

	Author:			Tomokazu ARITA
	update:			2001/11/27
*/

package hiformed.editor.mgpanel;

//import java.awt.Font;
//import java.awt.FontMetrics;
//import java.awt.Toolkit;

import java.awt.*;
import java.awt.geom.*;
import java.lang.*;
import java.awt.font.LineMetrics;

//import java.lang.Math;

public class Block{
	
	//}[W̐ݒɎgp
	public static final int TOP    = 1;
	public static final int BOTTOM = 2;
	public static final int LEFT   = 3;
	public static final int RIGHT  = 4; 
	public static final int CENTER = 5;
	
	//Blockւ̃|C^̐ݒp
	public static final int IN = 1;
	public static final int OV = 2;
	public static final int LF = 3;
	
	//Blockւ̃|C^̐ݒp
	public static final int START = 0;
	public static final int END   = 1;
	
	
	//Έʒu
	private int X_LOCATION = -1;
	private int Y_LOCATION = -1;
	
	//אڂBlockւ̃|C^
	private Block in_start = null;
	private Block in_end   = null;
	private Block ov_start = null;
	private Block ov_end   = null;
	private Block lf_start = null;
	private Block lf_end   = null;
	
	/*
	private int WIDTH = 0;
	private int HEIGHT = 0;
	*/
	
	
	//`p̐ݒ
	private static int LEFT_MARGIN   = 0;
	private static int RIGHT_MARGIN  = 0;
	private static int TOP_MARGIN    = 0;
	private static int BOTTOM_MARGIN = 0;
	
	private static int HWIDTH_BETWEEN_NODE_AND_CELL = 0;
	private static int VWIDTH_BETWEEN_NODE_AND_CELL = 0;
	
	private String title = new String();
	
	private static int NODE_RADIUS = 0;
	
	private static int CELL_LEFT_MARGIN   = 0;
	private static int CELL_RIGHT_MARGIN  = 0;
	private static int CELL_TOP_MARGIN    = 0;
	private static int CELL_BOTTOM_MARGIN = 0;
	
	private static int    FONT_SIZE  = 9;//original
	//private static int    FONT_SIZE  = 15;//for demo 0129
	private static int    FONT_STYLE = Font.BOLD;
	private static String FONT_NAME  = "Helvetica";
	private static Font   CELL_FONT  = new Font( FONT_NAME, FONT_STYLE, FONT_SIZE);
	
	
	//zup̐ݒ
	private int AR_WIDTH  = 1;
	private int AR_HEIGHT = 1;
	private int AR_LAYER  = 1;
	
	
	//ID
	private static int ID = 0;
	
	
	//?
	public  static final  int   MAX_BLOCK_NUMBER = 100;
	private static int[] MAX_WIDTH  = new int[MAX_BLOCK_NUMBER];
	private static int[] MAX_HEIGHT = new int[MAX_BLOCK_NUMBER] ;


	//RXgN^P
	public Block(){
		initBlock();
	}
	
	//RXgN^Q
	public Block(String title){
		this.title = title;
		initBlock();
	}
	
	//
	private void initBlock(){
	}
	
	//Blocǩ̕vZ
	public int getWidth(Graphics2D g2d){
		return ( LEFT_MARGIN + RIGHT_MARGIN
				 + NODE_RADIUS*2 + HWIDTH_BETWEEN_NODE_AND_CELL
				 + getCellWidth(g2d) );
	}
	
	//x(Z)̌̕vZ
	public int getCellWidth(Graphics2D g2d){
		FontMetrics fm = g2d.getFontMetrics(CELL_FONT);
		Rectangle2D rect2D = fm.getStringBounds(title, g2d);
		Double dswidth = new Double(rect2D.getWidth());
		int swidth = dswidth.intValue();
		return ( CELL_LEFT_MARGIN + CELL_RIGHT_MARGIN
				 + swidth );
	}
	
	//Block̍̌vZ
	public int getHeight(Graphics2D g2d){
		return ( TOP_MARGIN + BOTTOM_MARGIN 
				 + VWIDTH_BETWEEN_NODE_AND_CELL 
				 + NODE_RADIUS*2 
				 + getCellHeight(g2d) );
	}
	
	//xiZj̍̌vZ
	public int getCellHeight(Graphics2D g2d){
		FontMetrics fm = g2d.getFontMetrics(CELL_FONT);
		LineMetrics lm = fm.getLineMetrics(title, g2d);
		Rectangle2D rect2D = fm.getStringBounds(title, g2d);
		Float fa = new Float(lm.getAscent());
		Float fd = new Float(lm.getDescent());
		return ( CELL_TOP_MARGIN + CELL_BOTTOM_MARGIN 
				 + fa.intValue() 
				 + fd.intValue() );
	}
	
	//Block̃}[Wݒ
	public static void setMargin(int position, int value){
		
		switch(position){
			case TOP    : TOP_MARGIN    = value; break;
			case BOTTOM : BOTTOM_MARGIN = value; break;
			case LEFT   : LEFT_MARGIN   = value; break;
			case RIGHT  : RIGHT_MARGIN  = value; break;
		}
	}
	
	
	//Block̃}[Wݒ
	public static void setMargin(int position, int H_value, int V_value){
		
		switch(position){
			case CENTER :
				HWIDTH_BETWEEN_NODE_AND_CELL = H_value;
				VWIDTH_BETWEEN_NODE_AND_CELL = V_value;
				break;
		}
	}
	
	//CELL̃}[Wݒ
	public static void setCellMargin(int position, int value){
		
		switch(position){
			case TOP    : CELL_TOP_MARGIN    = value; break;
			case BOTTOM : CELL_BOTTOM_MARGIN = value; break;
			case LEFT   : CELL_LEFT_MARGIN   = value; break;
			case RIGHT  : CELL_RIGHT_MARGIN  = value; break;
		}
	}
	
	//Node̔a
	public static void setNodeRadius(int radius){
		NODE_RADIUS = radius;
	}
	
	//i΁jʒu̐ݒ
	public void setLocation(int x_location, int y_location){
		X_LOCATION = x_location;
		Y_LOCATION = y_location;
		
		
		System.out.println("TITLE;"+title+",x:"+X_LOCATION+","+"y:"+Y_LOCATION);/////////////
		
		//setMaxSize();
	}
	
	
	
	//אڃubNւ̃|C^ݒ
	public void setBlockPointer(int label, int start_or_end, Block block){
		
		switch(label){
			case IN :
				if(start_or_end == START){
					in_start = block;
				}else if(start_or_end == END){
					in_end = block;
				}
				break;
				
			case OV :
				if(start_or_end == START){
					ov_start = block;
				}else if(start_or_end == END){
					ov_end = block;
				}
				break;
				
			case LF :
				if(start_or_end == START){
					lf_start = block;
				}else if(start_or_end == END){
					lf_end = block;
				}
				break;
		}
	}
	
	//Node̕`W
	public Point getNodePoint(Point point, Graphics2D g2d){
		int X = LEFT_MARGIN + point.x;
		int Y = TOP_MARGIN 
				+ getCellHeight(g2d)
				+ VWIDTH_BETWEEN_NODE_AND_CELL 
				+ point.y;
		
		return new Point(X,Y);
	}
	
	//CELL̕`W
	public Point getCellPoint(Point point){
		
		int X = LEFT_MARGIN 
				+ NODE_RADIUS*2 
				+ HWIDTH_BETWEEN_NODE_AND_CELL 
				+ point.x;
		
		int Y = TOP_MARGIN 
				+ point.y;
		
		return new Point(X,Y);
	}
	
	//NODE̔a̐ݒ
	public int getNodeRadius(){
		return NODE_RADIUS;
	}
	
	//xXgO̕`Jn|Cg𓾂
	public Point getStringPoint(Point point, Graphics2D g2d){
		int X = LEFT_MARGIN 
				+ NODE_RADIUS*2 
				+ HWIDTH_BETWEEN_NODE_AND_CELL
				+ CELL_LEFT_MARGIN
				+ point.x;
		
		
		FontMetrics fm = g2d.getFontMetrics(CELL_FONT);
		LineMetrics lm = fm.getLineMetrics(title, g2d);
		Rectangle2D rect2D = fm.getStringBounds(title, g2d);
		Float fa = new Float(lm.getAscent());
		int Y = TOP_MARGIN 
				+ CELL_TOP_MARGIN  
				+ fa.intValue()
				+ point.y;
		
		return new Point(X,Y);
	}
	
	
	//xXgO`悷tHg𓾂
	public Font getTitleFont(){
		return CELL_FONT;
	}
	
	//xXgO𓾂
	public String getTitle(){
		return title;
	}
	
	//ׂBlock𓾂
	public Block getNeighborBlock(int label, int start_or_end){
		if(label == OV){
			if(start_or_end == START){
				return ov_start;
			}else if(start_or_end == END){
				return ov_end;
			}
		}else if(label == LF){
			if(start_or_end == START){
				return lf_start;
			}else if(start_or_end == END){
				return lf_end;
			}
		}else if(label == IN){
			if(start_or_end == START){
				return in_start;
			}else if(start_or_end == END){
				return in_end;
			}
		}
		
		return null;
	}
	
	
	public int getArWidth(){
		return AR_WIDTH;
	}
	
	public int getArHeight(){
		return AR_HEIGHT;
	}
	
	public int getArLayer(){
		return AR_LAYER;
	}
	
	public void setArLayer(int layer_number){
		this.AR_LAYER = layer_number;
		System.out.println("TITLE:"+title+",LN:"+AR_LAYER);///
	}
	
	public void setArSize(int width, int height){
		AR_WIDTH  = width;
		AR_HEIGHT = height;
	}
	
	
	//ID̐ݒiKNodeIDƈvj
	public void setID(int id){
		this.ID = id;
	}
	
	public int getXLocation(){
		return X_LOCATION;
	}
	
	public int getYLocation(){
		return Y_LOCATION;
	}



}