/* 
	FrameLayer.java

	Author: Tomokazu ARITA
	UpDate: 2001/03/08
	Last Update: 2001/12/06
	Since:  2001/03/08
*/

package hiformed.editor.table;

import java.awt.Graphics2D;
import java.awt.Point;
import java.awt.Dimension;
import java.util.Vector;
import java.awt.Color;
import java.awt.Rectangle;
import java.awt.BasicStroke;

public class FrameLayer extends Layer{
	
	private Vector cells = new Vector();
	
	public FrameLayer(){
		super();
	}	
		
	//C[̕`ig͂̕I[o[Chďj
	protected void drawLayer(Graphics2D g){
		drawCellFrame(g);
	}
	
	// draw a cell's frame
	private void drawCellFrame(Graphics2D g){
		for(int i=0; i<cells.size(); i++){
			Cell cell   = (Cell)cells.elementAt(i);
			Point point   = cell.getBasePoint();
			Dimension dim = cell.getCellSize();
			Color color   = cell.getFrameColor();
			int line_size = cell.getFrameLineSize();
		
			g.setColor(color);
			Rectangle rect = new Rectangle();
			rect.setLocation(point);
			rect.setSize(dim);
			g.setStroke(new BasicStroke((float)line_size));
			g.draw(rect);
		}
	}
	
	
	//Z̒ǉ
	public void setCell(Cell cell){
		cells.addElement(cell);
	}
	
	//C[̃NA
	public void clearLayer(){
		cells.removeAllElements();//o^ĂZ̍폜
		repaint();//ĕ`
	}
}
