/* 
	LayerManager.java

	Author:	Tomokazu ARITA
	UpDate: 2001/03/08
	Update: 2001/12/06
	Update: 2001/12/08
	Last Update 2001/12/09
	Since : 2001/02/28 
*/

package hiformed.editor.table;

import javax.swing.JPanel;
import javax.swing.JTextPane;
import javax.swing.JEditorPane;
import javax.swing.text.StyleConstants;


import java.awt.Point;
import java.awt.Dimension;
import java.awt.Insets;
import java.awt.Color;
import java.awt.Font;
import java.awt.Graphics2D;

import java.awt.Rectangle;
import java.awt.BasicStroke;

import javax.swing.text.DefaultStyledDocument;
import javax.swing.text.SimpleAttributeSet;

import javax.swing.JMenu;
import javax.swing.JMenuItem;
import javax.swing.Action;
import javax.swing.text.StyledEditorKit;

import java.awt.BorderLayout;

import javax.swing.JLabel;

import java.util.Vector;

public class LayerManager{
	
	private Layer layer                   = null;
	private BackgroundLayer bg_layer      = null; //Layer 1 Background
	private GridViewLayer grid_layer      = null; //Layer 2 Grid View
	private FormBackgroundLayer fbg_layer = null; //Layer 3 Form Background
	private FrameLayer frame_layer        = null; //Layer 4 Frame
	private ContentsLayer contents_layer  = null; //Layer 5 Contents
	
	private final Dimension layer_minimum_size   = new Dimension(200, 200);
	private final Dimension layer_preferred_size = new Dimension(1000, 1000);//
	
	private Vector cells = new Vector();//o^ꂽZ
	
	//RXgN^
	public LayerManager(){}
	
	
	//C[擾ƂɌĂяo܂B
	//ԂlBackground̃C[
	//߂̌ĂяoŊeC[̏s
	//C[gpƂ͕K̃\bhĂяoKvB
	private boolean  get_vp_flag = false;
	public Layer getLayers(){
		if(get_vp_flag == false){
			layer = initLayers();
			get_vp_flag = true;
		}
		
		return layer;
	}
		
	
	//Layeȑ
	private void initLayer(Layer layer){
		layer.setMinimumSize(layer_minimum_size);
		layer.setPreferredSize(layer_preferred_size);
		layer.setLayout(null);
		layer.setLocation(0,0);//
		layer.setSize(layer_preferred_size);//
	}
	

	
	//Layer 1: Background Layeȑ
	private void initBackgroundLayer(){
		bg_layer =  new BackgroundLayer();
		initLayer(bg_layer);
	}
	
	//Layer 2: Grid View Layeȑ
	private void initGridViewLayer(){
		grid_layer = new GridViewLayer();
		initLayer(grid_layer);
	}
	
	//Layer 3: Form Background Layeȑ
	private void initFormBackgroundLayer(){
		fbg_layer = new FormBackgroundLayer();
		initLayer(fbg_layer);
	}
	
	//Layer 4: Frame Layeȑ
	private void initFrameLayer(){
		frame_layer = new FrameLayer();
		initLayer(frame_layer);
	}
	
	//Layer 5: Contents Layeȑ
	private void initContentsLayer(Layer layer){
		contents_layer = new ContentsLayer(layer);
		initLayer(contents_layer);
		contents_layer.setLayout(null);// Layoutnullɐݒ
	}	
		
	
	//ׂĂLayeȑ
	private Layer initLayers(){
		layer = new Layer();//ԉ̃C[쐬
		initLayer(layer);//ňԉ̃C[
		layer.setBackground(Color.white);//wi͔
		
		initBackgroundLayer(); 		// Layer 1
		initGridViewLayer(); 		// Layer 2
		initFormBackgroundLayer(); 	// Layer 3
		initFrameLayer(); 			// Layer 4
		initContentsLayer(layer); 	// Layer 5
		
		
		layer.add(contents_layer);		
		layer.add(frame_layer);
		layer.add(fbg_layer);
		layer.add(grid_layer);
		layer.add(bg_layer);
		
		
		return layer;
	}
	
	
	
	/*
	// draw a cell, checking panel for drawing a cell
	public void drawCell(Cell cell){
		if(vpanel != null && vpanel.getBufferGraphics() != null){
			
			if(cell.getFrameOnOff() == cell.ON){ drawCellFrame(cell); }
			if(cell.getTitleOnOff() == cell.ON){ drawCellTitle(cell); }
			
			vpanel.repaint();
		}else{
			System.out.println("Error: can not draw a cell.");
		}
	}
	
	// draw a cell's frame
	private void drawCellFrame(Cell cell){
		Point point   = cell.getBasePoint();
		Dimension dim = cell.getCellSize();
		Color color   = cell.getFrameColor();
		int line_size = cell.getFrameLineSize();
		
		Graphics2D bufg2d = vpanel.getBufferGraphics();
		
		bufg2d.setColor(color);
		Rectangle rect = new Rectangle();
		rect.setLocation(point);
		rect.setSize(dim);
		bufg2d.setStroke(new BasicStroke((float)line_size));
		bufg2d.draw(rect);
	}
	*/
	
	
	/*
	// draw a cell's title.
	private void drawCellTitle(Cell cell){
		DefaultStyledDocument dsd = new DefaultStyledDocument();
		JTextPane text_pane = new JTextPane(dsd);
		text_pane = new JTextPane(dsd);
		//JEditorPane text_pane = new JEditorPane("text/plain", "TEST:");
		
		Point point   = cell.getBasePoint();
		Dimension dim = cell.getCellSize();
		String title  = cell.getTitle();
		
		text_pane.setLocation(point);
		text_pane.setSize(dim);
		
		
		try{
			SimpleAttributeSet attr = new SimpleAttributeSet();
			StyleConstants.setFontFamily(attr, "Times New Roman");
			StyleConstants.setFontSize(attr, 32);
			StyleConstants.setForeground(attr, Color.red);
			
			dsd.insertString(0,title, attr);
		}catch(Exception e){}
		
			
		text_pane.setCaretPosition(0);
		if(text_pane != null){
			contents_layer.add(text_pane);
		}else{
			System.out.println("--;");
		}
		
	}
	*/
	
	/*
	//set cell
	public void setCell(Cell cell){
		if(cell != null){
			drawCell(cell);
		}
	}
	*/	
	
	
	
	public JMenu creatStyleMenu(){
		JMenu style_menu = new JMenu("Edit");
		
		//Bold
		Action  action = new StyledEditorKit.BoldAction();
		action.putValue(Action.NAME, "Bold");//jdk 1.2
		style_menu.add(action);//jdk 1.2
		//JMenuItem item = new JMenuItem("Bold");
		//item.setAction(action);
		//style_menu.add(item);
		
		return style_menu;
	}
	
	
	
	public Layer getBGLayer(){
		return bg_layer;
	}
	
	public Layer getFrameLayer(){
		return frame_layer;
	}
	
	
	//C[̑傫ςƂiςƂjɌĂяo
	public void setAllLayerSize(Dimension d){
		bg_layer.clear();
		bg_layer.setSize(d);
		grid_layer.setSize(d);
		fbg_layer.setSize(d);
		frame_layer.setSize(d);
		contents_layer.setSize(d);
	}
	
	
	
	//set cell
	public void setCell(Cell cell){
		cells.addElement(cell);
	}
	
	// draw a cell, checking panel for drawing a cell
	public void drawCell(){
		
		clearLayers();//
		
		for(int i=0; i<cells.size(); i++){
			Cell cell   = (Cell)cells.elementAt(i);
			
			if(cell.getCellBGColorOnOff() == Cell.ON){ fbg_layer.setCell(cell); }
			if(cell.getFrameOnOff() == cell.ON){ frame_layer.setCell(cell); }
			if(cell.getTitleOnOff() == cell.ON){ contents_layer.drawCellTitle(cell);}
		}
		layer.repaint();
	}
	
	//OɃZꍇǂݍ
	public void setCellSet(Vector cells){
		this.cells = cells;
	}
	
	//clear
	public void clearLayers(){
		fbg_layer.clearLayer();
		frame_layer.clearLayer();
		contents_layer.clearLayer();
	}
}
