/* 
	DTBlock.java

	Author:			Tomokazu ARITA
	update:			2001/11/27	
*/

package hiformed.grammar;

public class DTBlock{
	
	private DTNode parent_node = null;//em[h
	private DTNode start_node  = null;//Jnm[h
	
	//for drawing block
	private int block_x = 0;
	private int block_y = 0;
	//private int block_width  = 0;
	//private int block_height = 0;

	public DTBlock(DTNode start_node){
		this.start_node = start_node;
	}
	
	public DTBlock(){
	}
	
	public void setParentNode(DTNode node){
		if(node != null){
			this.parent_node = node;
		}else{
			System.out.println("Error!");
		}
	}
	
	public void setStartNode(DTNode node){
		if(node != null){
			this.start_node = node;
		}else{
			System.out.println("Error!");
		}
	}
	
	public DTNode getStartNode(){
		return start_node;
	}
	
	public void setBlockX(int x){
		this.block_x = x;
	}
	
	public void setBlockY(int y){
		this.block_y = y;
	}
	
	public int getBlockX(){
		return block_x;
	}
	
	public int getBlockY(){
		return block_y;
	}

	public void addDTNode(DTNode node){
		if(start_node != null){
			DTNode temp_node = start_node;
			while(temp_node.getNextNode() != null){
				temp_node = temp_node.getNextNode();
			}
			temp_node.setNextNode(node);
		}else{
			start_node = node;
		}
	}
	
	public void addNewDTNode(
					int id, String label,
					int att_x, int att_y, 
					int add_width, int att_height){
		DTNode node = new DTNode();
		node.setNodeID(id);
		node.setNodeLabel(label);
		node.setAttX(att_x); node.setAttY(att_y);
		node.setAttWidth(add_width);
		node.setAttHeight(att_height);
		
		addDTNode(node);
	}
	
	
	//use on semantic rule
	public DTNode getNode(int node_number){
		DTNode node = start_node;
		
		if(node_number == 1){
			return node;
		}else if(node_number > 1){
			for(int i=1; i<node_number; i++){
				node = node.getNextNode();
				if(node == null){
					return null;//m[h
				}
			}
			return node;
		}
		
		return null;
	}
	
	
	
}
