/* 
	PTableA1.java

	Author:			Tomokazu ARITA
	update:			2001/11/28
*/


package hiformed.hngg.Precedence;

import hiformed.grammar.*;
import hiformed.hngg.NodeSet.*;

public class PTableA1 extends PrecedenceTable{

	//public static final int NumberOfA1NodeMarks = 35;
	//public static final int	NumberOfNodeMarks  = 35;
	//public static final int	NumberOfEdgeLabels = MGEdgeLabelSet.NumberofEdgeLabels;

	
	public PTableA1(){
		initTable();
	}
	
	public void initTable(){
		NumberOfNodeMarks  = 35;
		NumberOfEdgeLabels = MGEdgeLabelSet.NumberofEdgeLabels;
		
		PTable = new int [NumberOfNodeMarks][NumberOfEdgeLabels][NumberOfNodeMarks];
		
		for(int i=0; i<NumberOfNodeMarks; i++){
			for(int j=0; j<NumberOfEdgeLabels; j++){
				for(int k=0; k<NumberOfNodeMarks; k++){
					PTable[i][j][k] = PrecedenceTable.None;
				}
			}
		}
		
		setHeadPrecedence();
	}
	
	public void setHeadPrecedence(){
		
		PTable[NodeSetA1.A1_ROOT][MGEdgeLabelSet.IN][NodeSetA1.A1_GROUP] = PrecedenceTable.EdgeOfHandle;
		
		
		
		PTable[NodeSetA1.A1_ROW][MGEdgeLabelSet.OV][NodeSetA1.KEY_WORDS] = PrecedenceTable.HandleIsRight;
		PTable[NodeSetA1.A1_ROW][MGEdgeLabelSet.OV][NodeSetA1.CR_CODE] = PrecedenceTable.HandleIsRight;
		PTable[NodeSetA1.A1_ROW][MGEdgeLabelSet.OV][NodeSetA1.SCOPE] = PrecedenceTable.HandleIsRight;
		PTable[NodeSetA1.A1_ROW][MGEdgeLabelSet.OV][NodeSetA1.VARIANT] = PrecedenceTable.HandleIsRight;
		PTable[NodeSetA1.A1_ROW][MGEdgeLabelSet.OV][NodeSetA1.LANGUAGE] = PrecedenceTable.HandleIsRight;
		PTable[NodeSetA1.A1_ROW][MGEdgeLabelSet.OV][NodeSetA1.OPERATION] = PrecedenceTable.HandleIsRight;
		PTable[NodeSetA1.A1_ROW][MGEdgeLabelSet.OV][NodeSetA1.SOFTWARE_REQUIRE] = PrecedenceTable.HandleIsRight;
		PTable[NodeSetA1.A1_ROW][MGEdgeLabelSet.OV][NodeSetA1.HARDWARE_REQUIRE] = PrecedenceTable.HandleIsRight;
		PTable[NodeSetA1.A1_ROW][MGEdgeLabelSet.OV][NodeSetA1.REFERENCES] = PrecedenceTable.HandleIsRight;
		PTable[NodeSetA1.A1_ROW][MGEdgeLabelSet.OV][NodeSetA1.FUNCTION] = PrecedenceTable.HandleIsRight;
		PTable[NodeSetA1.A1_ROW][MGEdgeLabelSet.OV][NodeSetA1.EXAMPLE] = PrecedenceTable.HandleIsRight;
		
		PTable[NodeSetA1.A1_ROW][MGEdgeLabelSet.OV][NodeSetA1.A1_SCALAR] = PrecedenceTable.HandleIsRight;
		PTable[NodeSetA1.A1_ROW][MGEdgeLabelSet.OV][NodeSetA1.A1_COLUMN] = PrecedenceTable.HandleIsRight;
		PTable[NodeSetA1.A1_ROW][MGEdgeLabelSet.OV][NodeSetA1.A1_ROW] = PrecedenceTable.HandleIsRight;
		PTable[NodeSetA1.A1_ROW][MGEdgeLabelSet.OV][NodeSetA1.A1_ROOT] = PrecedenceTable.EdgeOfHandle;
		PTable[NodeSetA1.A1_ROW][MGEdgeLabelSet.IN][NodeSetA1.A1_GROUP] = PrecedenceTable.HandleIsLeft;
		
				
		
		PTable[NodeSetA1.A1_COLUMN][MGEdgeLabelSet.OV][NodeSetA1.KEY_WORDS] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.A1_COLUMN][MGEdgeLabelSet.OV][NodeSetA1.CR_CODE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.A1_COLUMN][MGEdgeLabelSet.OV][NodeSetA1.SCOPE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.A1_COLUMN][MGEdgeLabelSet.OV][NodeSetA1.VARIANT] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.A1_COLUMN][MGEdgeLabelSet.OV][NodeSetA1.LANGUAGE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.A1_COLUMN][MGEdgeLabelSet.OV][NodeSetA1.OPERATION] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.A1_COLUMN][MGEdgeLabelSet.OV][NodeSetA1.SOFTWARE_REQUIRE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.A1_COLUMN][MGEdgeLabelSet.OV][NodeSetA1.HARDWARE_REQUIRE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.A1_COLUMN][MGEdgeLabelSet.OV][NodeSetA1.REFERENCES] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.A1_COLUMN][MGEdgeLabelSet.OV][NodeSetA1.FUNCTION] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.A1_COLUMN][MGEdgeLabelSet.OV][NodeSetA1.EXAMPLE] = PrecedenceTable.HandleIsLeftRight;
		
		PTable[NodeSetA1.A1_COLUMN][MGEdgeLabelSet.OV][NodeSetA1.A1_SCALAR] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.A1_COLUMN][MGEdgeLabelSet.OV][NodeSetA1.A1_COLUMN] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.A1_COLUMN][MGEdgeLabelSet.OV][NodeSetA1.A1_ROW] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.A1_COLUMN][MGEdgeLabelSet.OV][NodeSetA1.A1_ROOT] = PrecedenceTable.HandleIsLeft;
		PTable[NodeSetA1.A1_COLUMN][MGEdgeLabelSet.IN][NodeSetA1.A1_GROUP] = PrecedenceTable.HandleIsLeft;
		
		
		
		PTable[NodeSetA1.A1_SCALAR][MGEdgeLabelSet.OV][NodeSetA1.KEY_WORDS] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.A1_SCALAR][MGEdgeLabelSet.LF][NodeSetA1.KEY_WORDS] = PrecedenceTable.HandleIsRight;
		PTable[NodeSetA1.A1_SCALAR][MGEdgeLabelSet.OV][NodeSetA1.CR_CODE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.A1_SCALAR][MGEdgeLabelSet.LF][NodeSetA1.CR_CODE] = PrecedenceTable.HandleIsRight;
		PTable[NodeSetA1.A1_SCALAR][MGEdgeLabelSet.OV][NodeSetA1.SCOPE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.A1_SCALAR][MGEdgeLabelSet.LF][NodeSetA1.SCOPE] = PrecedenceTable.HandleIsRight;
		PTable[NodeSetA1.A1_SCALAR][MGEdgeLabelSet.OV][NodeSetA1.VARIANT] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.A1_SCALAR][MGEdgeLabelSet.LF][NodeSetA1.VARIANT] = PrecedenceTable.HandleIsRight;
		PTable[NodeSetA1.A1_SCALAR][MGEdgeLabelSet.OV][NodeSetA1.LANGUAGE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.A1_SCALAR][MGEdgeLabelSet.LF][NodeSetA1.LANGUAGE] = PrecedenceTable.HandleIsRight;
		PTable[NodeSetA1.A1_SCALAR][MGEdgeLabelSet.OV][NodeSetA1.OPERATION] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.A1_SCALAR][MGEdgeLabelSet.LF][NodeSetA1.OPERATION] = PrecedenceTable.HandleIsRight;
		PTable[NodeSetA1.A1_SCALAR][MGEdgeLabelSet.OV][NodeSetA1.SOFTWARE_REQUIRE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.A1_SCALAR][MGEdgeLabelSet.LF][NodeSetA1.SOFTWARE_REQUIRE] = PrecedenceTable.HandleIsRight;
		PTable[NodeSetA1.A1_SCALAR][MGEdgeLabelSet.OV][NodeSetA1.HARDWARE_REQUIRE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.A1_SCALAR][MGEdgeLabelSet.LF][NodeSetA1.HARDWARE_REQUIRE] = PrecedenceTable.HandleIsRight;
		PTable[NodeSetA1.A1_SCALAR][MGEdgeLabelSet.OV][NodeSetA1.REFERENCES] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.A1_SCALAR][MGEdgeLabelSet.LF][NodeSetA1.REFERENCES] = PrecedenceTable.HandleIsRight;
		PTable[NodeSetA1.A1_SCALAR][MGEdgeLabelSet.OV][NodeSetA1.FUNCTION] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.A1_SCALAR][MGEdgeLabelSet.LF][NodeSetA1.FUNCTION] = PrecedenceTable.HandleIsRight;
		PTable[NodeSetA1.A1_SCALAR][MGEdgeLabelSet.OV][NodeSetA1.EXAMPLE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.A1_SCALAR][MGEdgeLabelSet.LF][NodeSetA1.EXAMPLE] = PrecedenceTable.HandleIsRight;
		
		PTable[NodeSetA1.A1_SCALAR][MGEdgeLabelSet.OV][NodeSetA1.A1_SCALAR] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.A1_SCALAR][MGEdgeLabelSet.LF][NodeSetA1.A1_SCALAR] = PrecedenceTable.HandleIsRight;
		PTable[NodeSetA1.A1_SCALAR][MGEdgeLabelSet.OV][NodeSetA1.A1_COLUMN] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.A1_SCALAR][MGEdgeLabelSet.LF][NodeSetA1.A1_COLUMN] = PrecedenceTable.EdgeOfHandle;
		
		PTable[NodeSetA1.A1_SCALAR][MGEdgeLabelSet.OV][NodeSetA1.A1_ROW] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.A1_SCALAR][MGEdgeLabelSet.OV][NodeSetA1.A1_ROOT] = PrecedenceTable.HandleIsLeft;
		PTable[NodeSetA1.A1_SCALAR][MGEdgeLabelSet.IN][NodeSetA1.A1_GROUP] = PrecedenceTable.HandleIsLeft;
		
		
		
		
		
		//KEY_WORDS
		PTable[NodeSetA1.KEY_WORDS][MGEdgeLabelSet.OV][NodeSetA1.KEY_WORDS] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.KEY_WORDS][MGEdgeLabelSet.LF][NodeSetA1.KEY_WORDS] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.KEY_WORDS][MGEdgeLabelSet.OV][NodeSetA1.CR_CODE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.KEY_WORDS][MGEdgeLabelSet.LF][NodeSetA1.CR_CODE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.KEY_WORDS][MGEdgeLabelSet.OV][NodeSetA1.SCOPE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.KEY_WORDS][MGEdgeLabelSet.LF][NodeSetA1.SCOPE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.KEY_WORDS][MGEdgeLabelSet.OV][NodeSetA1.VARIANT] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.KEY_WORDS][MGEdgeLabelSet.LF][NodeSetA1.VARIANT] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.KEY_WORDS][MGEdgeLabelSet.OV][NodeSetA1.LANGUAGE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.KEY_WORDS][MGEdgeLabelSet.LF][NodeSetA1.LANGUAGE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.KEY_WORDS][MGEdgeLabelSet.OV][NodeSetA1.OPERATION] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.KEY_WORDS][MGEdgeLabelSet.LF][NodeSetA1.OPERATION] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.KEY_WORDS][MGEdgeLabelSet.OV][NodeSetA1.SOFTWARE_REQUIRE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.KEY_WORDS][MGEdgeLabelSet.LF][NodeSetA1.SOFTWARE_REQUIRE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.KEY_WORDS][MGEdgeLabelSet.OV][NodeSetA1.HARDWARE_REQUIRE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.KEY_WORDS][MGEdgeLabelSet.LF][NodeSetA1.HARDWARE_REQUIRE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.KEY_WORDS][MGEdgeLabelSet.OV][NodeSetA1.REFERENCES] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.KEY_WORDS][MGEdgeLabelSet.LF][NodeSetA1.REFERENCES] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.KEY_WORDS][MGEdgeLabelSet.OV][NodeSetA1.FUNCTION] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.KEY_WORDS][MGEdgeLabelSet.LF][NodeSetA1.FUNCTION] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.KEY_WORDS][MGEdgeLabelSet.OV][NodeSetA1.EXAMPLE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.KEY_WORDS][MGEdgeLabelSet.LF][NodeSetA1.EXAMPLE] = PrecedenceTable.HandleIsLeftRight;
		
		PTable[NodeSetA1.KEY_WORDS][MGEdgeLabelSet.OV][NodeSetA1.A1_SCALAR] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.KEY_WORDS][MGEdgeLabelSet.LF][NodeSetA1.A1_SCALAR] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.KEY_WORDS][MGEdgeLabelSet.OV][NodeSetA1.A1_COLUMN] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.KEY_WORDS][MGEdgeLabelSet.LF][NodeSetA1.A1_COLUMN] = PrecedenceTable.HandleIsLeft;
		
		PTable[NodeSetA1.KEY_WORDS][MGEdgeLabelSet.OV][NodeSetA1.A1_ROW] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.KEY_WORDS][MGEdgeLabelSet.OV][NodeSetA1.A1_ROOT] = PrecedenceTable.HandleIsLeft;
		PTable[NodeSetA1.KEY_WORDS][MGEdgeLabelSet.IN][NodeSetA1.A1_GROUP] = PrecedenceTable.HandleIsLeft;
		
		
		//CR_CODE
		PTable[NodeSetA1.CR_CODE][MGEdgeLabelSet.OV][NodeSetA1.KEY_WORDS] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.CR_CODE][MGEdgeLabelSet.LF][NodeSetA1.KEY_WORDS] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.CR_CODE][MGEdgeLabelSet.OV][NodeSetA1.CR_CODE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.CR_CODE][MGEdgeLabelSet.LF][NodeSetA1.CR_CODE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.CR_CODE][MGEdgeLabelSet.OV][NodeSetA1.SCOPE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.CR_CODE][MGEdgeLabelSet.LF][NodeSetA1.SCOPE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.CR_CODE][MGEdgeLabelSet.OV][NodeSetA1.VARIANT] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.CR_CODE][MGEdgeLabelSet.LF][NodeSetA1.VARIANT] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.CR_CODE][MGEdgeLabelSet.OV][NodeSetA1.LANGUAGE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.CR_CODE][MGEdgeLabelSet.LF][NodeSetA1.LANGUAGE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.CR_CODE][MGEdgeLabelSet.OV][NodeSetA1.OPERATION] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.CR_CODE][MGEdgeLabelSet.LF][NodeSetA1.OPERATION] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.CR_CODE][MGEdgeLabelSet.OV][NodeSetA1.SOFTWARE_REQUIRE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.CR_CODE][MGEdgeLabelSet.LF][NodeSetA1.SOFTWARE_REQUIRE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.CR_CODE][MGEdgeLabelSet.OV][NodeSetA1.HARDWARE_REQUIRE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.CR_CODE][MGEdgeLabelSet.LF][NodeSetA1.HARDWARE_REQUIRE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.CR_CODE][MGEdgeLabelSet.OV][NodeSetA1.REFERENCES] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.CR_CODE][MGEdgeLabelSet.LF][NodeSetA1.REFERENCES] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.CR_CODE][MGEdgeLabelSet.OV][NodeSetA1.FUNCTION] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.CR_CODE][MGEdgeLabelSet.LF][NodeSetA1.FUNCTION] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.CR_CODE][MGEdgeLabelSet.OV][NodeSetA1.EXAMPLE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.CR_CODE][MGEdgeLabelSet.LF][NodeSetA1.EXAMPLE] = PrecedenceTable.HandleIsLeftRight;
		
		PTable[NodeSetA1.CR_CODE][MGEdgeLabelSet.OV][NodeSetA1.A1_SCALAR] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.CR_CODE][MGEdgeLabelSet.LF][NodeSetA1.A1_SCALAR] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.CR_CODE][MGEdgeLabelSet.OV][NodeSetA1.A1_COLUMN] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.CR_CODE][MGEdgeLabelSet.LF][NodeSetA1.A1_COLUMN] = PrecedenceTable.HandleIsLeft;
		
		PTable[NodeSetA1.CR_CODE][MGEdgeLabelSet.OV][NodeSetA1.A1_ROW] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.CR_CODE][MGEdgeLabelSet.OV][NodeSetA1.A1_ROOT] = PrecedenceTable.HandleIsLeft;
		PTable[NodeSetA1.CR_CODE][MGEdgeLabelSet.IN][NodeSetA1.A1_GROUP] = PrecedenceTable.HandleIsLeft;
		
		
		//SCOPE
		PTable[NodeSetA1.SCOPE][MGEdgeLabelSet.OV][NodeSetA1.KEY_WORDS] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.SCOPE][MGEdgeLabelSet.LF][NodeSetA1.KEY_WORDS] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.SCOPE][MGEdgeLabelSet.OV][NodeSetA1.CR_CODE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.SCOPE][MGEdgeLabelSet.LF][NodeSetA1.CR_CODE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.SCOPE][MGEdgeLabelSet.OV][NodeSetA1.SCOPE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.SCOPE][MGEdgeLabelSet.LF][NodeSetA1.SCOPE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.SCOPE][MGEdgeLabelSet.OV][NodeSetA1.VARIANT] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.SCOPE][MGEdgeLabelSet.LF][NodeSetA1.VARIANT] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.SCOPE][MGEdgeLabelSet.OV][NodeSetA1.LANGUAGE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.SCOPE][MGEdgeLabelSet.LF][NodeSetA1.LANGUAGE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.SCOPE][MGEdgeLabelSet.OV][NodeSetA1.OPERATION] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.SCOPE][MGEdgeLabelSet.LF][NodeSetA1.OPERATION] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.SCOPE][MGEdgeLabelSet.OV][NodeSetA1.SOFTWARE_REQUIRE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.SCOPE][MGEdgeLabelSet.LF][NodeSetA1.SOFTWARE_REQUIRE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.SCOPE][MGEdgeLabelSet.OV][NodeSetA1.HARDWARE_REQUIRE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.SCOPE][MGEdgeLabelSet.LF][NodeSetA1.HARDWARE_REQUIRE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.SCOPE][MGEdgeLabelSet.OV][NodeSetA1.REFERENCES] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.SCOPE][MGEdgeLabelSet.LF][NodeSetA1.REFERENCES] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.SCOPE][MGEdgeLabelSet.OV][NodeSetA1.FUNCTION] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.SCOPE][MGEdgeLabelSet.LF][NodeSetA1.FUNCTION] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.SCOPE][MGEdgeLabelSet.OV][NodeSetA1.EXAMPLE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.SCOPE][MGEdgeLabelSet.LF][NodeSetA1.EXAMPLE] = PrecedenceTable.HandleIsLeftRight;
		
		PTable[NodeSetA1.SCOPE][MGEdgeLabelSet.OV][NodeSetA1.A1_SCALAR] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.SCOPE][MGEdgeLabelSet.LF][NodeSetA1.A1_SCALAR] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.SCOPE][MGEdgeLabelSet.OV][NodeSetA1.A1_COLUMN] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.SCOPE][MGEdgeLabelSet.LF][NodeSetA1.A1_COLUMN] = PrecedenceTable.HandleIsLeft;
		
		PTable[NodeSetA1.SCOPE][MGEdgeLabelSet.OV][NodeSetA1.A1_ROW] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.SCOPE][MGEdgeLabelSet.OV][NodeSetA1.A1_ROOT] = PrecedenceTable.HandleIsLeft;
		PTable[NodeSetA1.SCOPE][MGEdgeLabelSet.IN][NodeSetA1.A1_GROUP] = PrecedenceTable.HandleIsLeft;
		
		//VARIANT
		PTable[NodeSetA1.VARIANT][MGEdgeLabelSet.OV][NodeSetA1.KEY_WORDS] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.VARIANT][MGEdgeLabelSet.LF][NodeSetA1.KEY_WORDS] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.VARIANT][MGEdgeLabelSet.OV][NodeSetA1.CR_CODE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.VARIANT][MGEdgeLabelSet.LF][NodeSetA1.CR_CODE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.VARIANT][MGEdgeLabelSet.OV][NodeSetA1.SCOPE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.VARIANT][MGEdgeLabelSet.LF][NodeSetA1.SCOPE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.VARIANT][MGEdgeLabelSet.OV][NodeSetA1.VARIANT] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.VARIANT][MGEdgeLabelSet.LF][NodeSetA1.VARIANT] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.VARIANT][MGEdgeLabelSet.OV][NodeSetA1.LANGUAGE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.VARIANT][MGEdgeLabelSet.LF][NodeSetA1.LANGUAGE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.VARIANT][MGEdgeLabelSet.OV][NodeSetA1.OPERATION] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.VARIANT][MGEdgeLabelSet.LF][NodeSetA1.OPERATION] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.VARIANT][MGEdgeLabelSet.OV][NodeSetA1.SOFTWARE_REQUIRE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.VARIANT][MGEdgeLabelSet.LF][NodeSetA1.SOFTWARE_REQUIRE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.VARIANT][MGEdgeLabelSet.OV][NodeSetA1.HARDWARE_REQUIRE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.VARIANT][MGEdgeLabelSet.LF][NodeSetA1.HARDWARE_REQUIRE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.VARIANT][MGEdgeLabelSet.OV][NodeSetA1.REFERENCES] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.VARIANT][MGEdgeLabelSet.LF][NodeSetA1.REFERENCES] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.VARIANT][MGEdgeLabelSet.OV][NodeSetA1.FUNCTION] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.VARIANT][MGEdgeLabelSet.LF][NodeSetA1.FUNCTION] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.VARIANT][MGEdgeLabelSet.OV][NodeSetA1.EXAMPLE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.VARIANT][MGEdgeLabelSet.LF][NodeSetA1.EXAMPLE] = PrecedenceTable.HandleIsLeftRight;
		
		PTable[NodeSetA1.VARIANT][MGEdgeLabelSet.OV][NodeSetA1.A1_SCALAR] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.VARIANT][MGEdgeLabelSet.LF][NodeSetA1.A1_SCALAR] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.VARIANT][MGEdgeLabelSet.OV][NodeSetA1.A1_COLUMN] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.VARIANT][MGEdgeLabelSet.LF][NodeSetA1.A1_COLUMN] = PrecedenceTable.HandleIsLeft;
		
		PTable[NodeSetA1.VARIANT][MGEdgeLabelSet.OV][NodeSetA1.A1_ROW] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.VARIANT][MGEdgeLabelSet.OV][NodeSetA1.A1_ROOT] = PrecedenceTable.HandleIsLeft;
		PTable[NodeSetA1.VARIANT][MGEdgeLabelSet.IN][NodeSetA1.A1_GROUP] = PrecedenceTable.HandleIsLeft;
		
		//LANGUAGE
		PTable[NodeSetA1.LANGUAGE][MGEdgeLabelSet.OV][NodeSetA1.KEY_WORDS] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.LANGUAGE][MGEdgeLabelSet.LF][NodeSetA1.KEY_WORDS] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.LANGUAGE][MGEdgeLabelSet.OV][NodeSetA1.CR_CODE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.LANGUAGE][MGEdgeLabelSet.LF][NodeSetA1.CR_CODE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.LANGUAGE][MGEdgeLabelSet.OV][NodeSetA1.SCOPE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.LANGUAGE][MGEdgeLabelSet.LF][NodeSetA1.SCOPE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.LANGUAGE][MGEdgeLabelSet.OV][NodeSetA1.VARIANT] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.LANGUAGE][MGEdgeLabelSet.LF][NodeSetA1.VARIANT] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.LANGUAGE][MGEdgeLabelSet.OV][NodeSetA1.LANGUAGE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.LANGUAGE][MGEdgeLabelSet.LF][NodeSetA1.LANGUAGE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.LANGUAGE][MGEdgeLabelSet.OV][NodeSetA1.OPERATION] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.LANGUAGE][MGEdgeLabelSet.LF][NodeSetA1.OPERATION] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.LANGUAGE][MGEdgeLabelSet.OV][NodeSetA1.SOFTWARE_REQUIRE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.LANGUAGE][MGEdgeLabelSet.LF][NodeSetA1.SOFTWARE_REQUIRE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.LANGUAGE][MGEdgeLabelSet.OV][NodeSetA1.HARDWARE_REQUIRE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.LANGUAGE][MGEdgeLabelSet.LF][NodeSetA1.HARDWARE_REQUIRE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.LANGUAGE][MGEdgeLabelSet.OV][NodeSetA1.REFERENCES] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.LANGUAGE][MGEdgeLabelSet.LF][NodeSetA1.REFERENCES] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.LANGUAGE][MGEdgeLabelSet.OV][NodeSetA1.FUNCTION] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.LANGUAGE][MGEdgeLabelSet.LF][NodeSetA1.FUNCTION] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.LANGUAGE][MGEdgeLabelSet.OV][NodeSetA1.EXAMPLE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.LANGUAGE][MGEdgeLabelSet.LF][NodeSetA1.EXAMPLE] = PrecedenceTable.HandleIsLeftRight;
		
		PTable[NodeSetA1.LANGUAGE][MGEdgeLabelSet.OV][NodeSetA1.A1_SCALAR] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.LANGUAGE][MGEdgeLabelSet.LF][NodeSetA1.A1_SCALAR] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.LANGUAGE][MGEdgeLabelSet.OV][NodeSetA1.A1_COLUMN] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.LANGUAGE][MGEdgeLabelSet.LF][NodeSetA1.A1_COLUMN] = PrecedenceTable.HandleIsLeft;
		
		PTable[NodeSetA1.LANGUAGE][MGEdgeLabelSet.OV][NodeSetA1.A1_ROW] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.LANGUAGE][MGEdgeLabelSet.OV][NodeSetA1.A1_ROOT] = PrecedenceTable.HandleIsLeft;
		PTable[NodeSetA1.LANGUAGE][MGEdgeLabelSet.IN][NodeSetA1.A1_GROUP] = PrecedenceTable.HandleIsLeft;
		
		//OPERATION
		PTable[NodeSetA1.OPERATION][MGEdgeLabelSet.OV][NodeSetA1.KEY_WORDS] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.OPERATION][MGEdgeLabelSet.LF][NodeSetA1.KEY_WORDS] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.OPERATION][MGEdgeLabelSet.OV][NodeSetA1.CR_CODE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.OPERATION][MGEdgeLabelSet.LF][NodeSetA1.CR_CODE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.OPERATION][MGEdgeLabelSet.OV][NodeSetA1.SCOPE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.OPERATION][MGEdgeLabelSet.LF][NodeSetA1.SCOPE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.OPERATION][MGEdgeLabelSet.OV][NodeSetA1.VARIANT] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.OPERATION][MGEdgeLabelSet.LF][NodeSetA1.VARIANT] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.OPERATION][MGEdgeLabelSet.OV][NodeSetA1.LANGUAGE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.OPERATION][MGEdgeLabelSet.LF][NodeSetA1.LANGUAGE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.OPERATION][MGEdgeLabelSet.OV][NodeSetA1.OPERATION] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.OPERATION][MGEdgeLabelSet.LF][NodeSetA1.OPERATION] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.OPERATION][MGEdgeLabelSet.OV][NodeSetA1.SOFTWARE_REQUIRE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.OPERATION][MGEdgeLabelSet.LF][NodeSetA1.SOFTWARE_REQUIRE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.OPERATION][MGEdgeLabelSet.OV][NodeSetA1.HARDWARE_REQUIRE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.OPERATION][MGEdgeLabelSet.LF][NodeSetA1.HARDWARE_REQUIRE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.OPERATION][MGEdgeLabelSet.OV][NodeSetA1.REFERENCES] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.OPERATION][MGEdgeLabelSet.LF][NodeSetA1.REFERENCES] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.OPERATION][MGEdgeLabelSet.OV][NodeSetA1.FUNCTION] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.OPERATION][MGEdgeLabelSet.LF][NodeSetA1.FUNCTION] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.OPERATION][MGEdgeLabelSet.OV][NodeSetA1.EXAMPLE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.OPERATION][MGEdgeLabelSet.LF][NodeSetA1.EXAMPLE] = PrecedenceTable.HandleIsLeftRight;
		
		PTable[NodeSetA1.OPERATION][MGEdgeLabelSet.OV][NodeSetA1.A1_SCALAR] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.OPERATION][MGEdgeLabelSet.LF][NodeSetA1.A1_SCALAR] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.OPERATION][MGEdgeLabelSet.OV][NodeSetA1.A1_COLUMN] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.OPERATION][MGEdgeLabelSet.LF][NodeSetA1.A1_COLUMN] = PrecedenceTable.HandleIsLeft;
		
		PTable[NodeSetA1.OPERATION][MGEdgeLabelSet.OV][NodeSetA1.A1_ROW] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.OPERATION][MGEdgeLabelSet.OV][NodeSetA1.A1_ROOT] = PrecedenceTable.HandleIsLeft;
		PTable[NodeSetA1.OPERATION][MGEdgeLabelSet.IN][NodeSetA1.A1_GROUP] = PrecedenceTable.HandleIsLeft;
		
		//SOFTWARE_REQUIRE
		PTable[NodeSetA1.SOFTWARE_REQUIRE][MGEdgeLabelSet.OV][NodeSetA1.KEY_WORDS] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.SOFTWARE_REQUIRE][MGEdgeLabelSet.LF][NodeSetA1.KEY_WORDS] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.SOFTWARE_REQUIRE][MGEdgeLabelSet.OV][NodeSetA1.CR_CODE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.SOFTWARE_REQUIRE][MGEdgeLabelSet.LF][NodeSetA1.CR_CODE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.SOFTWARE_REQUIRE][MGEdgeLabelSet.OV][NodeSetA1.SCOPE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.SOFTWARE_REQUIRE][MGEdgeLabelSet.LF][NodeSetA1.SCOPE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.SOFTWARE_REQUIRE][MGEdgeLabelSet.OV][NodeSetA1.VARIANT] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.SOFTWARE_REQUIRE][MGEdgeLabelSet.LF][NodeSetA1.VARIANT] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.SOFTWARE_REQUIRE][MGEdgeLabelSet.OV][NodeSetA1.LANGUAGE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.SOFTWARE_REQUIRE][MGEdgeLabelSet.LF][NodeSetA1.LANGUAGE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.SOFTWARE_REQUIRE][MGEdgeLabelSet.OV][NodeSetA1.OPERATION] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.SOFTWARE_REQUIRE][MGEdgeLabelSet.LF][NodeSetA1.OPERATION] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.SOFTWARE_REQUIRE][MGEdgeLabelSet.OV][NodeSetA1.SOFTWARE_REQUIRE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.SOFTWARE_REQUIRE][MGEdgeLabelSet.LF][NodeSetA1.SOFTWARE_REQUIRE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.SOFTWARE_REQUIRE][MGEdgeLabelSet.OV][NodeSetA1.HARDWARE_REQUIRE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.SOFTWARE_REQUIRE][MGEdgeLabelSet.LF][NodeSetA1.HARDWARE_REQUIRE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.SOFTWARE_REQUIRE][MGEdgeLabelSet.OV][NodeSetA1.REFERENCES] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.SOFTWARE_REQUIRE][MGEdgeLabelSet.LF][NodeSetA1.REFERENCES] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.SOFTWARE_REQUIRE][MGEdgeLabelSet.OV][NodeSetA1.FUNCTION] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.SOFTWARE_REQUIRE][MGEdgeLabelSet.LF][NodeSetA1.FUNCTION] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.SOFTWARE_REQUIRE][MGEdgeLabelSet.OV][NodeSetA1.EXAMPLE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.SOFTWARE_REQUIRE][MGEdgeLabelSet.LF][NodeSetA1.EXAMPLE] = PrecedenceTable.HandleIsLeftRight;
		
		PTable[NodeSetA1.SOFTWARE_REQUIRE][MGEdgeLabelSet.OV][NodeSetA1.A1_SCALAR] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.SOFTWARE_REQUIRE][MGEdgeLabelSet.LF][NodeSetA1.A1_SCALAR] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.SOFTWARE_REQUIRE][MGEdgeLabelSet.OV][NodeSetA1.A1_COLUMN] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.SOFTWARE_REQUIRE][MGEdgeLabelSet.LF][NodeSetA1.A1_COLUMN] = PrecedenceTable.HandleIsLeft;
		
		PTable[NodeSetA1.SOFTWARE_REQUIRE][MGEdgeLabelSet.OV][NodeSetA1.A1_ROW] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.SOFTWARE_REQUIRE][MGEdgeLabelSet.OV][NodeSetA1.A1_ROOT] = PrecedenceTable.HandleIsLeft;
		PTable[NodeSetA1.SOFTWARE_REQUIRE][MGEdgeLabelSet.IN][NodeSetA1.A1_GROUP] = PrecedenceTable.HandleIsLeft;
		
		//HARDWARE_REQUIRE
		PTable[NodeSetA1.HARDWARE_REQUIRE][MGEdgeLabelSet.OV][NodeSetA1.KEY_WORDS] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.HARDWARE_REQUIRE][MGEdgeLabelSet.LF][NodeSetA1.KEY_WORDS] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.HARDWARE_REQUIRE][MGEdgeLabelSet.OV][NodeSetA1.CR_CODE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.HARDWARE_REQUIRE][MGEdgeLabelSet.LF][NodeSetA1.CR_CODE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.HARDWARE_REQUIRE][MGEdgeLabelSet.OV][NodeSetA1.SCOPE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.HARDWARE_REQUIRE][MGEdgeLabelSet.LF][NodeSetA1.SCOPE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.HARDWARE_REQUIRE][MGEdgeLabelSet.OV][NodeSetA1.VARIANT] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.HARDWARE_REQUIRE][MGEdgeLabelSet.LF][NodeSetA1.VARIANT] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.HARDWARE_REQUIRE][MGEdgeLabelSet.OV][NodeSetA1.LANGUAGE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.HARDWARE_REQUIRE][MGEdgeLabelSet.LF][NodeSetA1.LANGUAGE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.HARDWARE_REQUIRE][MGEdgeLabelSet.OV][NodeSetA1.OPERATION] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.HARDWARE_REQUIRE][MGEdgeLabelSet.LF][NodeSetA1.OPERATION] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.HARDWARE_REQUIRE][MGEdgeLabelSet.OV][NodeSetA1.SOFTWARE_REQUIRE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.HARDWARE_REQUIRE][MGEdgeLabelSet.LF][NodeSetA1.SOFTWARE_REQUIRE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.HARDWARE_REQUIRE][MGEdgeLabelSet.OV][NodeSetA1.HARDWARE_REQUIRE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.HARDWARE_REQUIRE][MGEdgeLabelSet.LF][NodeSetA1.HARDWARE_REQUIRE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.HARDWARE_REQUIRE][MGEdgeLabelSet.OV][NodeSetA1.REFERENCES] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.HARDWARE_REQUIRE][MGEdgeLabelSet.LF][NodeSetA1.REFERENCES] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.HARDWARE_REQUIRE][MGEdgeLabelSet.OV][NodeSetA1.FUNCTION] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.HARDWARE_REQUIRE][MGEdgeLabelSet.LF][NodeSetA1.FUNCTION] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.HARDWARE_REQUIRE][MGEdgeLabelSet.OV][NodeSetA1.EXAMPLE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.HARDWARE_REQUIRE][MGEdgeLabelSet.LF][NodeSetA1.EXAMPLE] = PrecedenceTable.HandleIsLeftRight;
		
		PTable[NodeSetA1.HARDWARE_REQUIRE][MGEdgeLabelSet.OV][NodeSetA1.A1_SCALAR] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.HARDWARE_REQUIRE][MGEdgeLabelSet.LF][NodeSetA1.A1_SCALAR] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.HARDWARE_REQUIRE][MGEdgeLabelSet.OV][NodeSetA1.A1_COLUMN] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.HARDWARE_REQUIRE][MGEdgeLabelSet.LF][NodeSetA1.A1_COLUMN] = PrecedenceTable.HandleIsLeft;
		
		PTable[NodeSetA1.HARDWARE_REQUIRE][MGEdgeLabelSet.OV][NodeSetA1.A1_ROW] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.HARDWARE_REQUIRE][MGEdgeLabelSet.OV][NodeSetA1.A1_ROOT] = PrecedenceTable.HandleIsLeft;
		PTable[NodeSetA1.HARDWARE_REQUIRE][MGEdgeLabelSet.IN][NodeSetA1.A1_GROUP] = PrecedenceTable.HandleIsLeft;
		
		//REFERENCES
		PTable[NodeSetA1.REFERENCES][MGEdgeLabelSet.OV][NodeSetA1.KEY_WORDS] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.REFERENCES][MGEdgeLabelSet.LF][NodeSetA1.KEY_WORDS] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.REFERENCES][MGEdgeLabelSet.OV][NodeSetA1.CR_CODE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.REFERENCES][MGEdgeLabelSet.LF][NodeSetA1.CR_CODE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.REFERENCES][MGEdgeLabelSet.OV][NodeSetA1.SCOPE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.REFERENCES][MGEdgeLabelSet.LF][NodeSetA1.SCOPE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.REFERENCES][MGEdgeLabelSet.OV][NodeSetA1.VARIANT] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.REFERENCES][MGEdgeLabelSet.LF][NodeSetA1.VARIANT] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.REFERENCES][MGEdgeLabelSet.OV][NodeSetA1.LANGUAGE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.REFERENCES][MGEdgeLabelSet.LF][NodeSetA1.LANGUAGE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.REFERENCES][MGEdgeLabelSet.OV][NodeSetA1.OPERATION] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.REFERENCES][MGEdgeLabelSet.LF][NodeSetA1.OPERATION] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.REFERENCES][MGEdgeLabelSet.OV][NodeSetA1.SOFTWARE_REQUIRE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.REFERENCES][MGEdgeLabelSet.LF][NodeSetA1.SOFTWARE_REQUIRE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.REFERENCES][MGEdgeLabelSet.OV][NodeSetA1.HARDWARE_REQUIRE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.REFERENCES][MGEdgeLabelSet.LF][NodeSetA1.HARDWARE_REQUIRE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.REFERENCES][MGEdgeLabelSet.OV][NodeSetA1.REFERENCES] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.REFERENCES][MGEdgeLabelSet.LF][NodeSetA1.REFERENCES] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.REFERENCES][MGEdgeLabelSet.OV][NodeSetA1.FUNCTION] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.REFERENCES][MGEdgeLabelSet.LF][NodeSetA1.FUNCTION] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.REFERENCES][MGEdgeLabelSet.OV][NodeSetA1.EXAMPLE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.REFERENCES][MGEdgeLabelSet.LF][NodeSetA1.EXAMPLE] = PrecedenceTable.HandleIsLeftRight;
		
		PTable[NodeSetA1.REFERENCES][MGEdgeLabelSet.OV][NodeSetA1.A1_SCALAR] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.REFERENCES][MGEdgeLabelSet.LF][NodeSetA1.A1_SCALAR] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.REFERENCES][MGEdgeLabelSet.OV][NodeSetA1.A1_COLUMN] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.REFERENCES][MGEdgeLabelSet.LF][NodeSetA1.A1_COLUMN] = PrecedenceTable.HandleIsLeft;
		
		PTable[NodeSetA1.REFERENCES][MGEdgeLabelSet.OV][NodeSetA1.A1_ROW] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.REFERENCES][MGEdgeLabelSet.OV][NodeSetA1.A1_ROOT] = PrecedenceTable.HandleIsLeft;
		PTable[NodeSetA1.REFERENCES][MGEdgeLabelSet.IN][NodeSetA1.A1_GROUP] = PrecedenceTable.HandleIsLeft;
		
		//FUNCTION
		PTable[NodeSetA1.FUNCTION][MGEdgeLabelSet.OV][NodeSetA1.KEY_WORDS] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.FUNCTION][MGEdgeLabelSet.LF][NodeSetA1.KEY_WORDS] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.FUNCTION][MGEdgeLabelSet.OV][NodeSetA1.CR_CODE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.FUNCTION][MGEdgeLabelSet.LF][NodeSetA1.CR_CODE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.FUNCTION][MGEdgeLabelSet.OV][NodeSetA1.SCOPE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.FUNCTION][MGEdgeLabelSet.LF][NodeSetA1.SCOPE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.FUNCTION][MGEdgeLabelSet.OV][NodeSetA1.VARIANT] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.FUNCTION][MGEdgeLabelSet.LF][NodeSetA1.VARIANT] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.FUNCTION][MGEdgeLabelSet.OV][NodeSetA1.LANGUAGE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.FUNCTION][MGEdgeLabelSet.LF][NodeSetA1.LANGUAGE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.FUNCTION][MGEdgeLabelSet.OV][NodeSetA1.OPERATION] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.FUNCTION][MGEdgeLabelSet.LF][NodeSetA1.OPERATION] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.FUNCTION][MGEdgeLabelSet.OV][NodeSetA1.SOFTWARE_REQUIRE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.FUNCTION][MGEdgeLabelSet.LF][NodeSetA1.SOFTWARE_REQUIRE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.FUNCTION][MGEdgeLabelSet.OV][NodeSetA1.HARDWARE_REQUIRE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.FUNCTION][MGEdgeLabelSet.LF][NodeSetA1.HARDWARE_REQUIRE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.FUNCTION][MGEdgeLabelSet.OV][NodeSetA1.REFERENCES] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.FUNCTION][MGEdgeLabelSet.LF][NodeSetA1.REFERENCES] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.FUNCTION][MGEdgeLabelSet.OV][NodeSetA1.FUNCTION] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.FUNCTION][MGEdgeLabelSet.LF][NodeSetA1.FUNCTION] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.FUNCTION][MGEdgeLabelSet.OV][NodeSetA1.EXAMPLE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.FUNCTION][MGEdgeLabelSet.LF][NodeSetA1.EXAMPLE] = PrecedenceTable.HandleIsLeftRight;
		
		PTable[NodeSetA1.FUNCTION][MGEdgeLabelSet.OV][NodeSetA1.A1_SCALAR] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.FUNCTION][MGEdgeLabelSet.LF][NodeSetA1.A1_SCALAR] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.FUNCTION][MGEdgeLabelSet.OV][NodeSetA1.A1_COLUMN] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.FUNCTION][MGEdgeLabelSet.LF][NodeSetA1.A1_COLUMN] = PrecedenceTable.HandleIsLeft;
		
		PTable[NodeSetA1.FUNCTION][MGEdgeLabelSet.OV][NodeSetA1.A1_ROW] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.FUNCTION][MGEdgeLabelSet.OV][NodeSetA1.A1_ROOT] = PrecedenceTable.HandleIsLeft;
		PTable[NodeSetA1.FUNCTION][MGEdgeLabelSet.IN][NodeSetA1.A1_GROUP] = PrecedenceTable.HandleIsLeft;
		
		//EXAMPLE
		PTable[NodeSetA1.EXAMPLE][MGEdgeLabelSet.OV][NodeSetA1.KEY_WORDS] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.EXAMPLE][MGEdgeLabelSet.LF][NodeSetA1.KEY_WORDS] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.EXAMPLE][MGEdgeLabelSet.OV][NodeSetA1.CR_CODE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.EXAMPLE][MGEdgeLabelSet.LF][NodeSetA1.CR_CODE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.EXAMPLE][MGEdgeLabelSet.OV][NodeSetA1.SCOPE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.EXAMPLE][MGEdgeLabelSet.LF][NodeSetA1.SCOPE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.EXAMPLE][MGEdgeLabelSet.OV][NodeSetA1.VARIANT] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.EXAMPLE][MGEdgeLabelSet.LF][NodeSetA1.VARIANT] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.EXAMPLE][MGEdgeLabelSet.OV][NodeSetA1.LANGUAGE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.EXAMPLE][MGEdgeLabelSet.LF][NodeSetA1.LANGUAGE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.EXAMPLE][MGEdgeLabelSet.OV][NodeSetA1.OPERATION] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.EXAMPLE][MGEdgeLabelSet.LF][NodeSetA1.OPERATION] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.EXAMPLE][MGEdgeLabelSet.OV][NodeSetA1.SOFTWARE_REQUIRE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.EXAMPLE][MGEdgeLabelSet.LF][NodeSetA1.SOFTWARE_REQUIRE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.EXAMPLE][MGEdgeLabelSet.OV][NodeSetA1.HARDWARE_REQUIRE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.EXAMPLE][MGEdgeLabelSet.LF][NodeSetA1.HARDWARE_REQUIRE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.EXAMPLE][MGEdgeLabelSet.OV][NodeSetA1.REFERENCES] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.EXAMPLE][MGEdgeLabelSet.LF][NodeSetA1.REFERENCES] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.EXAMPLE][MGEdgeLabelSet.OV][NodeSetA1.FUNCTION] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.EXAMPLE][MGEdgeLabelSet.LF][NodeSetA1.FUNCTION] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.EXAMPLE][MGEdgeLabelSet.OV][NodeSetA1.EXAMPLE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.EXAMPLE][MGEdgeLabelSet.LF][NodeSetA1.EXAMPLE] = PrecedenceTable.HandleIsLeftRight;
		
		PTable[NodeSetA1.EXAMPLE][MGEdgeLabelSet.OV][NodeSetA1.A1_SCALAR] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.EXAMPLE][MGEdgeLabelSet.LF][NodeSetA1.A1_SCALAR] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.EXAMPLE][MGEdgeLabelSet.OV][NodeSetA1.A1_COLUMN] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.EXAMPLE][MGEdgeLabelSet.LF][NodeSetA1.A1_COLUMN] = PrecedenceTable.HandleIsLeft;
		
		PTable[NodeSetA1.EXAMPLE][MGEdgeLabelSet.OV][NodeSetA1.A1_ROW] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.EXAMPLE][MGEdgeLabelSet.OV][NodeSetA1.A1_ROOT] = PrecedenceTable.HandleIsLeft;
		PTable[NodeSetA1.EXAMPLE][MGEdgeLabelSet.IN][NodeSetA1.A1_GROUP] = PrecedenceTable.HandleIsLeft;
		
		
		
		PTable[NodeSetA1.HEAD_GROUP][MGEdgeLabelSet.OV][NodeSetA1.A1] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.HEAD][MGEdgeLabelSet.OV][NodeSetA1.A1] = PrecedenceTable.HandleIsRight;
		
		PTable[NodeSetA1.HEAD_GROUP][MGEdgeLabelSet.OV][NodeSetA1.A1_GROUP] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.HEAD][MGEdgeLabelSet.OV][NodeSetA1.A1_GROUP] = PrecedenceTable.HandleIsRight;
		//A1 end
		
		
		
		//Head
		PTable[NodeSetA1.HEAD_ROOT][MGEdgeLabelSet.IN][NodeSetA1.HEAD_GROUP] = PrecedenceTable.EdgeOfHandle;
		
		
		
		PTable[NodeSetA1.HEAD_ROW][MGEdgeLabelSet.OV][NodeSetA1.PROGRAM_NAME] = PrecedenceTable.HandleIsRight;
		PTable[NodeSetA1.HEAD_ROW][MGEdgeLabelSet.OV][NodeSetA1.SUBTITLE] = PrecedenceTable.HandleIsRight;
		PTable[NodeSetA1.HEAD_ROW][MGEdgeLabelSet.OV][NodeSetA1.LIBRARY_CODE] = PrecedenceTable.HandleIsRight;
		PTable[NodeSetA1.HEAD_ROW][MGEdgeLabelSet.OV][NodeSetA1.VERSION] = PrecedenceTable.HandleIsRight;
		PTable[NodeSetA1.HEAD_ROW][MGEdgeLabelSet.OV][NodeSetA1.AUTHOR] = PrecedenceTable.HandleIsRight;
		PTable[NodeSetA1.HEAD_ROW][MGEdgeLabelSet.OV][NodeSetA1.APPROVER] = PrecedenceTable.HandleIsRight;
		PTable[NodeSetA1.HEAD_ROW][MGEdgeLabelSet.OV][NodeSetA1.ORIGINAL_RELEASE] = PrecedenceTable.HandleIsRight;
		PTable[NodeSetA1.HEAD_ROW][MGEdgeLabelSet.OV][NodeSetA1.CORRENT_RELEASE] = PrecedenceTable.HandleIsRight;
		
		PTable[NodeSetA1.HEAD_ROW][MGEdgeLabelSet.OV][NodeSetA1.HEAD_SCALAR] = PrecedenceTable.HandleIsRight;
		PTable[NodeSetA1.HEAD_ROW][MGEdgeLabelSet.OV][NodeSetA1.HEAD_COLUMN] = PrecedenceTable.HandleIsRight;
		PTable[NodeSetA1.HEAD_ROW][MGEdgeLabelSet.OV][NodeSetA1.HEAD_ROW] = PrecedenceTable.HandleIsRight;
		PTable[NodeSetA1.HEAD_ROW][MGEdgeLabelSet.OV][NodeSetA1.HEAD_ROOT] = PrecedenceTable.EdgeOfHandle;
		PTable[NodeSetA1.HEAD_ROW][MGEdgeLabelSet.IN][NodeSetA1.HEAD_GROUP] = PrecedenceTable.HandleIsLeft;
		
				
		
		PTable[NodeSetA1.HEAD_COLUMN][MGEdgeLabelSet.OV][NodeSetA1.PROGRAM_NAME] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.HEAD_COLUMN][MGEdgeLabelSet.OV][NodeSetA1.SUBTITLE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.HEAD_COLUMN][MGEdgeLabelSet.OV][NodeSetA1.LIBRARY_CODE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.HEAD_COLUMN][MGEdgeLabelSet.OV][NodeSetA1.VERSION] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.HEAD_COLUMN][MGEdgeLabelSet.OV][NodeSetA1.AUTHOR] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.HEAD_COLUMN][MGEdgeLabelSet.OV][NodeSetA1.APPROVER] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.HEAD_COLUMN][MGEdgeLabelSet.OV][NodeSetA1.ORIGINAL_RELEASE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.HEAD_COLUMN][MGEdgeLabelSet.OV][NodeSetA1.CORRENT_RELEASE] = PrecedenceTable.HandleIsLeftRight;
		
		PTable[NodeSetA1.HEAD_COLUMN][MGEdgeLabelSet.OV][NodeSetA1.HEAD_SCALAR] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.HEAD_COLUMN][MGEdgeLabelSet.OV][NodeSetA1.HEAD_COLUMN] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.HEAD_COLUMN][MGEdgeLabelSet.OV][NodeSetA1.HEAD_ROW] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.HEAD_COLUMN][MGEdgeLabelSet.OV][NodeSetA1.HEAD_ROOT] = PrecedenceTable.HandleIsLeft;
		PTable[NodeSetA1.HEAD_COLUMN][MGEdgeLabelSet.IN][NodeSetA1.HEAD_GROUP] = PrecedenceTable.HandleIsLeft;
		
		
		
		PTable[NodeSetA1.HEAD_SCALAR][MGEdgeLabelSet.OV][NodeSetA1.PROGRAM_NAME] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.HEAD_SCALAR][MGEdgeLabelSet.LF][NodeSetA1.PROGRAM_NAME] = PrecedenceTable.HandleIsRight;
		PTable[NodeSetA1.HEAD_SCALAR][MGEdgeLabelSet.OV][NodeSetA1.SUBTITLE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.HEAD_SCALAR][MGEdgeLabelSet.LF][NodeSetA1.SUBTITLE] = PrecedenceTable.HandleIsRight;
		PTable[NodeSetA1.HEAD_SCALAR][MGEdgeLabelSet.OV][NodeSetA1.LIBRARY_CODE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.HEAD_SCALAR][MGEdgeLabelSet.LF][NodeSetA1.LIBRARY_CODE] = PrecedenceTable.HandleIsRight;
		PTable[NodeSetA1.HEAD_SCALAR][MGEdgeLabelSet.OV][NodeSetA1.VERSION] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.HEAD_SCALAR][MGEdgeLabelSet.LF][NodeSetA1.VERSION] = PrecedenceTable.HandleIsRight;
		PTable[NodeSetA1.HEAD_SCALAR][MGEdgeLabelSet.OV][NodeSetA1.AUTHOR] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.HEAD_SCALAR][MGEdgeLabelSet.LF][NodeSetA1.AUTHOR] = PrecedenceTable.HandleIsRight;
		PTable[NodeSetA1.HEAD_SCALAR][MGEdgeLabelSet.OV][NodeSetA1.APPROVER] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.HEAD_SCALAR][MGEdgeLabelSet.LF][NodeSetA1.APPROVER] = PrecedenceTable.HandleIsRight;
		PTable[NodeSetA1.HEAD_SCALAR][MGEdgeLabelSet.OV][NodeSetA1.ORIGINAL_RELEASE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.HEAD_SCALAR][MGEdgeLabelSet.LF][NodeSetA1.ORIGINAL_RELEASE] = PrecedenceTable.HandleIsRight;
		PTable[NodeSetA1.HEAD_SCALAR][MGEdgeLabelSet.OV][NodeSetA1.CORRENT_RELEASE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.HEAD_SCALAR][MGEdgeLabelSet.LF][NodeSetA1.CORRENT_RELEASE] = PrecedenceTable.HandleIsRight;
		
		PTable[NodeSetA1.HEAD_SCALAR][MGEdgeLabelSet.OV][NodeSetA1.HEAD_SCALAR] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.HEAD_SCALAR][MGEdgeLabelSet.LF][NodeSetA1.HEAD_SCALAR] = PrecedenceTable.HandleIsRight;
		PTable[NodeSetA1.HEAD_SCALAR][MGEdgeLabelSet.OV][NodeSetA1.HEAD_COLUMN] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.HEAD_SCALAR][MGEdgeLabelSet.LF][NodeSetA1.HEAD_COLUMN] = PrecedenceTable.EdgeOfHandle;
		
		PTable[NodeSetA1.HEAD_SCALAR][MGEdgeLabelSet.OV][NodeSetA1.HEAD_ROW] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.HEAD_SCALAR][MGEdgeLabelSet.OV][NodeSetA1.HEAD_ROOT] = PrecedenceTable.HandleIsLeft;
		PTable[NodeSetA1.HEAD_SCALAR][MGEdgeLabelSet.IN][NodeSetA1.HEAD_GROUP] = PrecedenceTable.HandleIsLeft;
		
		
		
		//PROGRAM_NAME
		PTable[NodeSetA1.PROGRAM_NAME][MGEdgeLabelSet.OV][NodeSetA1.PROGRAM_NAME] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.PROGRAM_NAME][MGEdgeLabelSet.LF][NodeSetA1.PROGRAM_NAME] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.PROGRAM_NAME][MGEdgeLabelSet.OV][NodeSetA1.SUBTITLE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.PROGRAM_NAME][MGEdgeLabelSet.LF][NodeSetA1.SUBTITLE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.PROGRAM_NAME][MGEdgeLabelSet.OV][NodeSetA1.LIBRARY_CODE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.PROGRAM_NAME][MGEdgeLabelSet.LF][NodeSetA1.LIBRARY_CODE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.PROGRAM_NAME][MGEdgeLabelSet.OV][NodeSetA1.VERSION] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.PROGRAM_NAME][MGEdgeLabelSet.LF][NodeSetA1.VERSION] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.PROGRAM_NAME][MGEdgeLabelSet.OV][NodeSetA1.AUTHOR] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.PROGRAM_NAME][MGEdgeLabelSet.LF][NodeSetA1.AUTHOR] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.PROGRAM_NAME][MGEdgeLabelSet.OV][NodeSetA1.APPROVER] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.PROGRAM_NAME][MGEdgeLabelSet.LF][NodeSetA1.APPROVER] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.PROGRAM_NAME][MGEdgeLabelSet.OV][NodeSetA1.ORIGINAL_RELEASE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.PROGRAM_NAME][MGEdgeLabelSet.LF][NodeSetA1.ORIGINAL_RELEASE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.PROGRAM_NAME][MGEdgeLabelSet.OV][NodeSetA1.CORRENT_RELEASE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.PROGRAM_NAME][MGEdgeLabelSet.LF][NodeSetA1.CORRENT_RELEASE] = PrecedenceTable.HandleIsLeftRight;
		
		PTable[NodeSetA1.PROGRAM_NAME][MGEdgeLabelSet.OV][NodeSetA1.HEAD_SCALAR] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.PROGRAM_NAME][MGEdgeLabelSet.LF][NodeSetA1.HEAD_SCALAR] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.PROGRAM_NAME][MGEdgeLabelSet.OV][NodeSetA1.HEAD_COLUMN] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.PROGRAM_NAME][MGEdgeLabelSet.LF][NodeSetA1.HEAD_COLUMN] = PrecedenceTable.HandleIsLeft;
		
		PTable[NodeSetA1.PROGRAM_NAME][MGEdgeLabelSet.OV][NodeSetA1.HEAD_ROW] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.PROGRAM_NAME][MGEdgeLabelSet.OV][NodeSetA1.HEAD_ROOT] = PrecedenceTable.HandleIsLeft;
		PTable[NodeSetA1.PROGRAM_NAME][MGEdgeLabelSet.IN][NodeSetA1.HEAD_GROUP] = PrecedenceTable.HandleIsLeft;
		
		//SUBTITLE
		PTable[NodeSetA1.SUBTITLE][MGEdgeLabelSet.OV][NodeSetA1.PROGRAM_NAME] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.SUBTITLE][MGEdgeLabelSet.LF][NodeSetA1.PROGRAM_NAME] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.SUBTITLE][MGEdgeLabelSet.OV][NodeSetA1.SUBTITLE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.SUBTITLE][MGEdgeLabelSet.LF][NodeSetA1.SUBTITLE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.SUBTITLE][MGEdgeLabelSet.OV][NodeSetA1.LIBRARY_CODE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.SUBTITLE][MGEdgeLabelSet.LF][NodeSetA1.LIBRARY_CODE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.SUBTITLE][MGEdgeLabelSet.OV][NodeSetA1.VERSION] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.SUBTITLE][MGEdgeLabelSet.LF][NodeSetA1.VERSION] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.SUBTITLE][MGEdgeLabelSet.OV][NodeSetA1.AUTHOR] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.SUBTITLE][MGEdgeLabelSet.LF][NodeSetA1.AUTHOR] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.SUBTITLE][MGEdgeLabelSet.OV][NodeSetA1.APPROVER] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.SUBTITLE][MGEdgeLabelSet.LF][NodeSetA1.APPROVER] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.SUBTITLE][MGEdgeLabelSet.OV][NodeSetA1.ORIGINAL_RELEASE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.SUBTITLE][MGEdgeLabelSet.LF][NodeSetA1.ORIGINAL_RELEASE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.SUBTITLE][MGEdgeLabelSet.OV][NodeSetA1.CORRENT_RELEASE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.SUBTITLE][MGEdgeLabelSet.LF][NodeSetA1.CORRENT_RELEASE] = PrecedenceTable.HandleIsLeftRight;
		
		PTable[NodeSetA1.SUBTITLE][MGEdgeLabelSet.OV][NodeSetA1.HEAD_SCALAR] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.SUBTITLE][MGEdgeLabelSet.LF][NodeSetA1.HEAD_SCALAR] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.SUBTITLE][MGEdgeLabelSet.OV][NodeSetA1.HEAD_COLUMN] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.SUBTITLE][MGEdgeLabelSet.LF][NodeSetA1.HEAD_COLUMN] = PrecedenceTable.HandleIsLeft;
		
		PTable[NodeSetA1.SUBTITLE][MGEdgeLabelSet.OV][NodeSetA1.HEAD_ROW] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.SUBTITLE][MGEdgeLabelSet.OV][NodeSetA1.HEAD_ROOT] = PrecedenceTable.HandleIsLeft;
		PTable[NodeSetA1.SUBTITLE][MGEdgeLabelSet.IN][NodeSetA1.HEAD_GROUP] = PrecedenceTable.HandleIsLeft;
		
		//LIBRARY_CODE
		PTable[NodeSetA1.LIBRARY_CODE][MGEdgeLabelSet.OV][NodeSetA1.PROGRAM_NAME] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.LIBRARY_CODE][MGEdgeLabelSet.LF][NodeSetA1.PROGRAM_NAME] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.LIBRARY_CODE][MGEdgeLabelSet.OV][NodeSetA1.SUBTITLE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.LIBRARY_CODE][MGEdgeLabelSet.LF][NodeSetA1.SUBTITLE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.LIBRARY_CODE][MGEdgeLabelSet.OV][NodeSetA1.LIBRARY_CODE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.LIBRARY_CODE][MGEdgeLabelSet.LF][NodeSetA1.LIBRARY_CODE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.LIBRARY_CODE][MGEdgeLabelSet.OV][NodeSetA1.VERSION] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.LIBRARY_CODE][MGEdgeLabelSet.LF][NodeSetA1.VERSION] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.LIBRARY_CODE][MGEdgeLabelSet.OV][NodeSetA1.AUTHOR] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.LIBRARY_CODE][MGEdgeLabelSet.LF][NodeSetA1.AUTHOR] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.LIBRARY_CODE][MGEdgeLabelSet.OV][NodeSetA1.APPROVER] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.LIBRARY_CODE][MGEdgeLabelSet.LF][NodeSetA1.APPROVER] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.LIBRARY_CODE][MGEdgeLabelSet.OV][NodeSetA1.ORIGINAL_RELEASE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.LIBRARY_CODE][MGEdgeLabelSet.LF][NodeSetA1.ORIGINAL_RELEASE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.LIBRARY_CODE][MGEdgeLabelSet.OV][NodeSetA1.CORRENT_RELEASE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.LIBRARY_CODE][MGEdgeLabelSet.LF][NodeSetA1.CORRENT_RELEASE] = PrecedenceTable.HandleIsLeftRight;
		
		PTable[NodeSetA1.LIBRARY_CODE][MGEdgeLabelSet.OV][NodeSetA1.HEAD_SCALAR] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.LIBRARY_CODE][MGEdgeLabelSet.LF][NodeSetA1.HEAD_SCALAR] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.LIBRARY_CODE][MGEdgeLabelSet.OV][NodeSetA1.HEAD_COLUMN] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.LIBRARY_CODE][MGEdgeLabelSet.LF][NodeSetA1.HEAD_COLUMN] = PrecedenceTable.HandleIsLeft;
		
		PTable[NodeSetA1.LIBRARY_CODE][MGEdgeLabelSet.OV][NodeSetA1.HEAD_ROW] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.LIBRARY_CODE][MGEdgeLabelSet.OV][NodeSetA1.HEAD_ROOT] = PrecedenceTable.HandleIsLeft;
		PTable[NodeSetA1.LIBRARY_CODE][MGEdgeLabelSet.IN][NodeSetA1.HEAD_GROUP] = PrecedenceTable.HandleIsLeft;
		
		//VERSION
		PTable[NodeSetA1.VERSION][MGEdgeLabelSet.OV][NodeSetA1.PROGRAM_NAME] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.VERSION][MGEdgeLabelSet.LF][NodeSetA1.PROGRAM_NAME] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.VERSION][MGEdgeLabelSet.OV][NodeSetA1.SUBTITLE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.VERSION][MGEdgeLabelSet.LF][NodeSetA1.SUBTITLE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.VERSION][MGEdgeLabelSet.OV][NodeSetA1.LIBRARY_CODE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.VERSION][MGEdgeLabelSet.LF][NodeSetA1.LIBRARY_CODE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.VERSION][MGEdgeLabelSet.OV][NodeSetA1.VERSION] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.VERSION][MGEdgeLabelSet.LF][NodeSetA1.VERSION] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.VERSION][MGEdgeLabelSet.OV][NodeSetA1.AUTHOR] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.VERSION][MGEdgeLabelSet.LF][NodeSetA1.AUTHOR] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.VERSION][MGEdgeLabelSet.OV][NodeSetA1.APPROVER] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.VERSION][MGEdgeLabelSet.LF][NodeSetA1.APPROVER] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.VERSION][MGEdgeLabelSet.OV][NodeSetA1.ORIGINAL_RELEASE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.VERSION][MGEdgeLabelSet.LF][NodeSetA1.ORIGINAL_RELEASE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.VERSION][MGEdgeLabelSet.OV][NodeSetA1.CORRENT_RELEASE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.VERSION][MGEdgeLabelSet.LF][NodeSetA1.CORRENT_RELEASE] = PrecedenceTable.HandleIsLeftRight;
		
		PTable[NodeSetA1.VERSION][MGEdgeLabelSet.OV][NodeSetA1.HEAD_SCALAR] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.VERSION][MGEdgeLabelSet.LF][NodeSetA1.HEAD_SCALAR] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.VERSION][MGEdgeLabelSet.OV][NodeSetA1.HEAD_COLUMN] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.VERSION][MGEdgeLabelSet.LF][NodeSetA1.HEAD_COLUMN] = PrecedenceTable.HandleIsLeft;
		
		PTable[NodeSetA1.VERSION][MGEdgeLabelSet.OV][NodeSetA1.HEAD_ROW] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.VERSION][MGEdgeLabelSet.OV][NodeSetA1.HEAD_ROOT] = PrecedenceTable.HandleIsLeft;
		PTable[NodeSetA1.VERSION][MGEdgeLabelSet.IN][NodeSetA1.HEAD_GROUP] = PrecedenceTable.HandleIsLeft;
		
		//AUTHOR
		PTable[NodeSetA1.AUTHOR][MGEdgeLabelSet.OV][NodeSetA1.PROGRAM_NAME] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.AUTHOR][MGEdgeLabelSet.LF][NodeSetA1.PROGRAM_NAME] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.AUTHOR][MGEdgeLabelSet.OV][NodeSetA1.SUBTITLE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.AUTHOR][MGEdgeLabelSet.LF][NodeSetA1.SUBTITLE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.AUTHOR][MGEdgeLabelSet.OV][NodeSetA1.LIBRARY_CODE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.AUTHOR][MGEdgeLabelSet.LF][NodeSetA1.LIBRARY_CODE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.AUTHOR][MGEdgeLabelSet.OV][NodeSetA1.VERSION] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.AUTHOR][MGEdgeLabelSet.LF][NodeSetA1.VERSION] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.AUTHOR][MGEdgeLabelSet.OV][NodeSetA1.AUTHOR] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.AUTHOR][MGEdgeLabelSet.LF][NodeSetA1.AUTHOR] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.AUTHOR][MGEdgeLabelSet.OV][NodeSetA1.APPROVER] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.AUTHOR][MGEdgeLabelSet.LF][NodeSetA1.APPROVER] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.AUTHOR][MGEdgeLabelSet.OV][NodeSetA1.ORIGINAL_RELEASE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.AUTHOR][MGEdgeLabelSet.LF][NodeSetA1.ORIGINAL_RELEASE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.AUTHOR][MGEdgeLabelSet.OV][NodeSetA1.CORRENT_RELEASE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.AUTHOR][MGEdgeLabelSet.LF][NodeSetA1.CORRENT_RELEASE] = PrecedenceTable.HandleIsLeftRight;
		
		PTable[NodeSetA1.AUTHOR][MGEdgeLabelSet.OV][NodeSetA1.HEAD_SCALAR] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.AUTHOR][MGEdgeLabelSet.LF][NodeSetA1.HEAD_SCALAR] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.AUTHOR][MGEdgeLabelSet.OV][NodeSetA1.HEAD_COLUMN] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.AUTHOR][MGEdgeLabelSet.LF][NodeSetA1.HEAD_COLUMN] = PrecedenceTable.HandleIsLeft;
		
		PTable[NodeSetA1.AUTHOR][MGEdgeLabelSet.OV][NodeSetA1.HEAD_ROW] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.AUTHOR][MGEdgeLabelSet.OV][NodeSetA1.HEAD_ROOT] = PrecedenceTable.HandleIsLeft;
		PTable[NodeSetA1.AUTHOR][MGEdgeLabelSet.IN][NodeSetA1.HEAD_GROUP] = PrecedenceTable.HandleIsLeft;
		
		//APPROVER
		PTable[NodeSetA1.APPROVER][MGEdgeLabelSet.OV][NodeSetA1.PROGRAM_NAME] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.APPROVER][MGEdgeLabelSet.LF][NodeSetA1.PROGRAM_NAME] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.APPROVER][MGEdgeLabelSet.OV][NodeSetA1.SUBTITLE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.APPROVER][MGEdgeLabelSet.LF][NodeSetA1.SUBTITLE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.APPROVER][MGEdgeLabelSet.OV][NodeSetA1.LIBRARY_CODE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.APPROVER][MGEdgeLabelSet.LF][NodeSetA1.LIBRARY_CODE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.APPROVER][MGEdgeLabelSet.OV][NodeSetA1.VERSION] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.APPROVER][MGEdgeLabelSet.LF][NodeSetA1.VERSION] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.APPROVER][MGEdgeLabelSet.OV][NodeSetA1.AUTHOR] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.APPROVER][MGEdgeLabelSet.LF][NodeSetA1.AUTHOR] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.APPROVER][MGEdgeLabelSet.OV][NodeSetA1.APPROVER] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.APPROVER][MGEdgeLabelSet.LF][NodeSetA1.APPROVER] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.APPROVER][MGEdgeLabelSet.OV][NodeSetA1.ORIGINAL_RELEASE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.APPROVER][MGEdgeLabelSet.LF][NodeSetA1.ORIGINAL_RELEASE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.APPROVER][MGEdgeLabelSet.OV][NodeSetA1.CORRENT_RELEASE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.APPROVER][MGEdgeLabelSet.LF][NodeSetA1.CORRENT_RELEASE] = PrecedenceTable.HandleIsLeftRight;
		
		PTable[NodeSetA1.APPROVER][MGEdgeLabelSet.OV][NodeSetA1.HEAD_SCALAR] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.APPROVER][MGEdgeLabelSet.LF][NodeSetA1.HEAD_SCALAR] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.APPROVER][MGEdgeLabelSet.OV][NodeSetA1.HEAD_COLUMN] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.APPROVER][MGEdgeLabelSet.LF][NodeSetA1.HEAD_COLUMN] = PrecedenceTable.HandleIsLeft;
		
		PTable[NodeSetA1.APPROVER][MGEdgeLabelSet.OV][NodeSetA1.HEAD_ROW] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.APPROVER][MGEdgeLabelSet.OV][NodeSetA1.HEAD_ROOT] = PrecedenceTable.HandleIsLeft;
		PTable[NodeSetA1.APPROVER][MGEdgeLabelSet.IN][NodeSetA1.HEAD_GROUP] = PrecedenceTable.HandleIsLeft;
		
		//ORIGINAL_RELEASE
		PTable[NodeSetA1.ORIGINAL_RELEASE][MGEdgeLabelSet.OV][NodeSetA1.PROGRAM_NAME] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.ORIGINAL_RELEASE][MGEdgeLabelSet.LF][NodeSetA1.PROGRAM_NAME] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.ORIGINAL_RELEASE][MGEdgeLabelSet.OV][NodeSetA1.SUBTITLE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.ORIGINAL_RELEASE][MGEdgeLabelSet.LF][NodeSetA1.SUBTITLE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.ORIGINAL_RELEASE][MGEdgeLabelSet.OV][NodeSetA1.LIBRARY_CODE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.ORIGINAL_RELEASE][MGEdgeLabelSet.LF][NodeSetA1.LIBRARY_CODE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.ORIGINAL_RELEASE][MGEdgeLabelSet.OV][NodeSetA1.VERSION] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.ORIGINAL_RELEASE][MGEdgeLabelSet.LF][NodeSetA1.VERSION] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.ORIGINAL_RELEASE][MGEdgeLabelSet.OV][NodeSetA1.AUTHOR] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.ORIGINAL_RELEASE][MGEdgeLabelSet.LF][NodeSetA1.AUTHOR] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.ORIGINAL_RELEASE][MGEdgeLabelSet.OV][NodeSetA1.APPROVER] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.ORIGINAL_RELEASE][MGEdgeLabelSet.LF][NodeSetA1.APPROVER] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.ORIGINAL_RELEASE][MGEdgeLabelSet.OV][NodeSetA1.ORIGINAL_RELEASE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.ORIGINAL_RELEASE][MGEdgeLabelSet.LF][NodeSetA1.ORIGINAL_RELEASE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.ORIGINAL_RELEASE][MGEdgeLabelSet.OV][NodeSetA1.CORRENT_RELEASE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.ORIGINAL_RELEASE][MGEdgeLabelSet.LF][NodeSetA1.CORRENT_RELEASE] = PrecedenceTable.HandleIsLeftRight;
		
		PTable[NodeSetA1.ORIGINAL_RELEASE][MGEdgeLabelSet.OV][NodeSetA1.HEAD_SCALAR] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.ORIGINAL_RELEASE][MGEdgeLabelSet.LF][NodeSetA1.HEAD_SCALAR] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.ORIGINAL_RELEASE][MGEdgeLabelSet.OV][NodeSetA1.HEAD_COLUMN] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.ORIGINAL_RELEASE][MGEdgeLabelSet.LF][NodeSetA1.HEAD_COLUMN] = PrecedenceTable.HandleIsLeft;
		
		PTable[NodeSetA1.ORIGINAL_RELEASE][MGEdgeLabelSet.OV][NodeSetA1.HEAD_ROW] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.ORIGINAL_RELEASE][MGEdgeLabelSet.OV][NodeSetA1.HEAD_ROOT] = PrecedenceTable.HandleIsLeft;
		PTable[NodeSetA1.ORIGINAL_RELEASE][MGEdgeLabelSet.IN][NodeSetA1.HEAD_GROUP] = PrecedenceTable.HandleIsLeft;
		
		//CORRENT_RELEASE
		PTable[NodeSetA1.CORRENT_RELEASE][MGEdgeLabelSet.OV][NodeSetA1.PROGRAM_NAME] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.CORRENT_RELEASE][MGEdgeLabelSet.LF][NodeSetA1.PROGRAM_NAME] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.CORRENT_RELEASE][MGEdgeLabelSet.OV][NodeSetA1.SUBTITLE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.CORRENT_RELEASE][MGEdgeLabelSet.LF][NodeSetA1.SUBTITLE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.CORRENT_RELEASE][MGEdgeLabelSet.OV][NodeSetA1.LIBRARY_CODE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.CORRENT_RELEASE][MGEdgeLabelSet.LF][NodeSetA1.LIBRARY_CODE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.CORRENT_RELEASE][MGEdgeLabelSet.OV][NodeSetA1.VERSION] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.CORRENT_RELEASE][MGEdgeLabelSet.LF][NodeSetA1.VERSION] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.CORRENT_RELEASE][MGEdgeLabelSet.OV][NodeSetA1.AUTHOR] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.CORRENT_RELEASE][MGEdgeLabelSet.LF][NodeSetA1.AUTHOR] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.CORRENT_RELEASE][MGEdgeLabelSet.OV][NodeSetA1.APPROVER] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.CORRENT_RELEASE][MGEdgeLabelSet.LF][NodeSetA1.APPROVER] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.CORRENT_RELEASE][MGEdgeLabelSet.OV][NodeSetA1.ORIGINAL_RELEASE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.CORRENT_RELEASE][MGEdgeLabelSet.LF][NodeSetA1.ORIGINAL_RELEASE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.CORRENT_RELEASE][MGEdgeLabelSet.OV][NodeSetA1.CORRENT_RELEASE] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.CORRENT_RELEASE][MGEdgeLabelSet.LF][NodeSetA1.CORRENT_RELEASE] = PrecedenceTable.HandleIsLeftRight;
		
		PTable[NodeSetA1.CORRENT_RELEASE][MGEdgeLabelSet.OV][NodeSetA1.HEAD_SCALAR] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.CORRENT_RELEASE][MGEdgeLabelSet.LF][NodeSetA1.HEAD_SCALAR] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.CORRENT_RELEASE][MGEdgeLabelSet.OV][NodeSetA1.HEAD_COLUMN] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.CORRENT_RELEASE][MGEdgeLabelSet.LF][NodeSetA1.HEAD_COLUMN] = PrecedenceTable.HandleIsLeft;
		
		PTable[NodeSetA1.CORRENT_RELEASE][MGEdgeLabelSet.OV][NodeSetA1.HEAD_ROW] = PrecedenceTable.HandleIsLeftRight;
		PTable[NodeSetA1.CORRENT_RELEASE][MGEdgeLabelSet.OV][NodeSetA1.HEAD_ROOT] = PrecedenceTable.HandleIsLeft;
		PTable[NodeSetA1.CORRENT_RELEASE][MGEdgeLabelSet.IN][NodeSetA1.HEAD_GROUP] = PrecedenceTable.HandleIsLeft;
		
		
		
		PTable[NodeSetA1.HEAD_GROUP][MGEdgeLabelSet.IN][NodeSetA1.FORM] = PrecedenceTable.HandleIsLeft;
		PTable[NodeSetA1.HEAD][MGEdgeLabelSet.IN][NodeSetA1.FORM] = PrecedenceTable.HandleIsLeft;
		PTable[NodeSetA1.INNER_STRUCT][MGEdgeLabelSet.IN][NodeSetA1.FORM] = PrecedenceTable.EdgeOfHandle;
		
		PTable[NodeSetA1.HEAD_GROUP][MGEdgeLabelSet.OV][NodeSetA1.BODY] = PrecedenceTable.HandleIsLeft;
		PTable[NodeSetA1.HEAD][MGEdgeLabelSet.OV][NodeSetA1.BODY] = PrecedenceTable.EdgeOfHandle;
	}
}