/* 
	H5.java

	Author:			Tomokazu ARITA
	update:			2001/11/28
*/


package hiformed.hngg.Productions;

import hiformed.grammar.*;
import hiformed.hngg.NodeSet.*;
import hiformed.hngg.SemanticRules.*;

public class H5 extends Production{

	public H5(){
		//Production name
		setProductionName("H5");
		
		// Left Hand Side
		MGNode left = new MGNode();
		left.setNodeLabel(NodeSetA1.HEAD_COLUMN);
		left.setNodeID(0);
		setLeftHandSide(left);
		
		//Right Hand Side
		MGNode node1 = new MGNode();
		node1.setNodeLabel(NodeSetA1.HEAD_SCALAR);
		node1.setNodeID(1);
		
		MGNode node2 = new MGNode();
		node2.setNodeLabel(NodeSetA1.HEAD_COLUMN);
		node2.setNodeID(2);
		
		node1.setLfStartNode(node2);
		node2.setLfEndNode(node1);
		
		MarkedGraph right = new MarkedGraph();
		right.setStartNode(node1);
		setRightHandSide(right);
		
		//Connection Relation
		ConnectionRelation cr1 = new ConnectionRelation(
										NodeSetA1.ALL_LABEL,
										MGEdgeLabelSet.IN,
										MGEdgeLabelSet.IN,
										node1.getNodeID(),
										ConnectionRelation.OUT
									  );
		
		ConnectionRelation cr2 = new ConnectionRelation(
										NodeSetA1.ALL_LABEL,
										MGEdgeLabelSet.OV,
										MGEdgeLabelSet.OV,
										node1.getNodeID(),
										ConnectionRelation.IN
									  );
		
		ConnectionRelation cr3 = new ConnectionRelation(
										NodeSetA1.ALL_LABEL,
										MGEdgeLabelSet.OV,
										MGEdgeLabelSet.OV,
										node1.getNodeID(),
										ConnectionRelation.OUT
									  );
		
		ConnectionRelation cr4 = new ConnectionRelation(
										NodeSetA1.ALL_LABEL,
										MGEdgeLabelSet.LF,
										MGEdgeLabelSet.LF,
										node1.getNodeID(),
										ConnectionRelation.IN
									  );
		
		addCR(cr1);
		addCR(cr2);
		addCR(cr3);
		addCR(cr4);
		
		//Semantic Rule
		setSemanticRule(new SH5());
	}
	
}