/* 
	H7.java

	Author:			Tomokazu ARITA
	update:			2001/11/28
*/


package hiformed.hngg.Productions;

import hiformed.grammar.*;
import hiformed.hngg.NodeSet.*;
import hiformed.hngg.SemanticRules.*;

public class H7 extends Production{

	public H7(){
		//Production name
		setProductionName("H7");
		
		// Left Hand Side
		MGNode left = new MGNode();
		left.setNodeLabel(NodeSetA1.HEAD_SCALAR);
		left.setNodeID(0);
		setLeftHandSide(left);
		
		//Right Hand Side
		MGNode node1 = new MGNode();
		node1.setNodeLabel(NodeSetA1.PROGRAM_NAME);
		node1.setNodeID(1);
				
		MarkedGraph right = new MarkedGraph();
		right.setStartNode(node1);
		setRightHandSide(right);
		
		//Connection Relation
		ConnectionRelation cr1 = new ConnectionRelation(
										NodeSetA1.ALL_LABEL,
										MGEdgeLabelSet.IN,
										MGEdgeLabelSet.IN,
										node1.getNodeID(),
										ConnectionRelation.OUT
									  );
		
		ConnectionRelation cr2 = new ConnectionRelation(
										NodeSetA1.ALL_LABEL,
										MGEdgeLabelSet.OV,
										MGEdgeLabelSet.OV,
										node1.getNodeID(),
										ConnectionRelation.IN
									  );
		
		ConnectionRelation cr3 = new ConnectionRelation(
										NodeSetA1.ALL_LABEL,
										MGEdgeLabelSet.OV,
										MGEdgeLabelSet.OV,
										node1.getNodeID(),
										ConnectionRelation.OUT
									  );
		
		ConnectionRelation cr4 = new ConnectionRelation(
										NodeSetA1.ALL_LABEL,
										MGEdgeLabelSet.LF,
										MGEdgeLabelSet.LF,
										node1.getNodeID(),
										ConnectionRelation.IN
									  );
		
		ConnectionRelation cr5 = new ConnectionRelation(
										NodeSetA1.ALL_LABEL,
										MGEdgeLabelSet.LF,
										MGEdgeLabelSet.LF,
										node1.getNodeID(),
										ConnectionRelation.OUT
									  );
		
		addCR(cr1);
		addCR(cr2);
		addCR(cr3);
		addCR(cr4);
		addCR(cr5);
		
		//Semantic Rule
		setSemanticRule(new SH7());
	}
	
}